#include <bits/stdc++.h>

using namespace std;

const int N = 2e5 + 7;
vector <int> g[N];
vector <pair <int, int>> max_st[N]; // <dp, tin>
int T = 0;

void add_to_st(int d, int dp, int tin) {
    auto &st = max_st[d];
    while (!st.empty() && st.back().first <= dp) {
        st.pop_back();
    }
    st.emplace_back(dp, tin);
}

int get_max(int d, int tin_thresh) {
    auto &st = max_st[d];
    while (st.size() > 1 && st[(int) st.size() - 2].second >= tin_thresh) {
        st.pop_back();
    }
    return st.back().first;
}

int dfs(int v, int d = 0) {
    int tin = T++;
    
    if (g[v].empty()) {
        add_to_st(d, 0, tin);
        return d;
    }

    int min_leaf_depth = -1;
    for (int u : g[v]) {
        int rec_min_leaf_depth = dfs(u, d + 1);
        if (min_leaf_depth == -1 || rec_min_leaf_depth < min_leaf_depth) {
            min_leaf_depth = rec_min_leaf_depth;
        }
    }

    int ans = 1 + get_max(min_leaf_depth, tin);
    add_to_st(d, ans, tin);
    return min_leaf_depth;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    for (int i = 2; i <= n; i++) {
        int p;
        cin >> p;
        g[p].push_back(i);
    }
    dfs(1);
    cout << max_st[0][0].first << '\n';
    return 0;
}