#include <bits/stdc++.h>

using namespace std;

const int N = 2e5 + 7;
vector <int> g[N];
vector <pair <int, int>> on_depth[N]; // <dp, tin>
int T = 0;

int get_max(int d, int tin_thresh) {
    auto &layer = on_depth[d];
    int ans = 0;
    int uk = layer.size() - 1;
    while (uk >= 0 && layer[uk].second >= tin_thresh) {
        ans = max(ans, layer[uk--].first);
    }
    return ans;
}

int dfs(int v, int d = 0) {
    int tin = T++;
    
    if (g[v].empty()) {
        on_depth[d].emplace_back(0, tin);
        return d;
    }

    int min_leaf_depth = -1;
    for (int u : g[v]) {
        int rec_min_leaf_depth = dfs(u, d + 1);
        if (min_leaf_depth == -1 || rec_min_leaf_depth < min_leaf_depth) {
            min_leaf_depth = rec_min_leaf_depth;
        }
    }

    on_depth[d].emplace_back(1 + get_max(min_leaf_depth, tin), tin);
    return min_leaf_depth;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    int n;
    cin >> n;
    for (int i = 2; i <= n; i++) {
        int p;
        cin >> p;
        g[p].push_back(i);
    }
    dfs(1);
    cout << on_depth[0][0].first << '\n';
    return 0;
}