/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

#define all(c) c.begin(), c.end()

template<typename T>
struct v {
    T x, y;
    v() : x(0), y(0) {}
    v(T x, T y) : x(x), y(y) {}

    v<T> operator*(T alpha) const { return v<T>(x * alpha, y * alpha); }
    v<T> operator+(v<T> const &r) { return v<T>(x + r.x, y + r.y); }
    v<T> operator-(v<T> const &r) { return v<T>(x - r.x, y - r.y); }
    v<T> operator-() { return v<T>(-x, -y); }

    T dsqr() const { return x * x + y * y; }
    bool sp() const { return y > 0 || y == 0 && x > 0; }
    bool operator==(v<T> const &r) const { return x == r.x && y == r.y; }
    bool operator!=(v<T> const &r) const { return x != r.x || y != r.y; }

    T operator*(v<T> const &r) const { return x * r.x + y * r.y; }
    T operator%(v<T> const &r) const { return x * r.y - y * r.x; }
};

// @formatter:off idiotic clion
template<typename T>
istream &operator>>(istream &in, v<T> &vec) {
    return in >> vec.x >> vec.y;
}
// @formatter:on

int main() {

    using vec = v<ll>;
    in(int, n)
    vector<vec> pts(n);
    cin >> pts;

    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; i++) {
        in(int, u, v)
        u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    int answer = n - 1;
    vector<unordered_set<int>> match;
    vector<int> vis;
    function<void(int)> go = [&](int v) {
        vis[v] = 1;
        for (int u : match[v]) {
            if (vis[u]) continue;
            go(u);
            vis[v] += vis[u];
        }
    };

    for (int v = 0; v < n; v++) {
        if (g[v].size() < 2) continue;

        match.assign(g[v].size(), unordered_set<int>{});
        vis.assign(g[v].size(), 0);
        sort(all(g[v]), [&](int e1, int e2) {
            auto u1 = pts[e1] - pts[v], u2 = pts[e2] - pts[v];
            auto u1sp = u1.sp(), u2sp = u2.sp();
            if (u1sp != u2sp) return u1sp;
            return u1 % u2 > 0;
        });

#define fwd(_i) (_i < g[v].size() - 1 ? _i + 1 : 0)
        int before = 0;
        for (int i = 0; i < g[v].size(); i++) {
            auto dir = pts[v] - pts[g[v][i]];
            vec u1, u2 = pts[g[v][before]] - pts[v];
            for (;; before = fwd(before)) {
                u1 = u2;
                u2 = pts[g[v][fwd(before)]] - pts[v];
                if (u2 % dir < 0 || u2 == -dir) break;
            }
            if (before != i) match[i].insert(before);
            int after = fwd(before);
            if (after != i && (u1 % dir != 0 || u1 * dir < 0)) match[i].insert(after);
        }

        vector<int> rm;
        for (int i = 0; i < g[v].size(); i++) {
            rm.clear();
            for (int j : match[i]) {
                if (match[j].count(i) == 0) rm.push_back(j);
            }
            for (int j : rm) match[i].erase(j);
        }

        for (int i = 0; i < g[v].size(); i++) {
            if (vis[i]) continue;
            go(i);
            answer -= vis[i] / 2;
        }
    }

    cout << answer << '\n';

}