#include <iostream>
#include <set>
#include <unordered_map>
using namespace std;
typedef long long int lli;
typedef pair<lli, lli> plli;
typedef unordered_map<lli, lli>::iterator it;

const lli MAX_SIZE = (lli)1e5,
          MOD = (lli)1e9 + 7LL;

class Node {
public:
    lli zero;
    lli one;
    lli two;

    Node(lli _zero, lli _one, lli _two) {
        zero = _zero;
        one = _one;
        two = _two;
        return;
    }

    bool operator < (const Node &n) const {
        if (this->zero != n.zero)
            return this->zero < n.zero;
        if (this->one != n.one)
            return this->one < n.one;
        return this->two < n.two;
    }
};

lli N,
    k;
lli tmp_ans,
    ans;
set<Node> used;

lli modpow(lli base, lli ptr) {
    if (ptr == 0LL)
        return 1LL;
    if (ptr % 2LL == 0LL) {
        lli half = modpow(base, ptr / 2LL);
        return (half * half) % MOD;
    }
    return (base * modpow(base, ptr - 1LL)) % MOD;
}

void add(lli num, unordered_map<lli, lli> &m) {
    for (lli d = 2LL; d * d <= num; ++d)
        while (num % d == 0LL) {
            num /= d;
            ++m[d];
        }
    if (num > 1LL)
        ++m[num];
    return;
}

void f(lli zero, lli one, lli two) {
    if (zero + one + two == k) {
        if (one + 2LL * two != k + 1LL)
            return;
        if (used.find(Node(zero, one, two)) != used.end())
            return;

        used.insert(Node(zero, one, two));

        unordered_map<lli, lli> a,
                                b;
        for (lli x = 1LL; x <= k; ++x)
            add(x, a);
        for (lli x = 1LL; x <= zero; ++x)
            add(x, b);
        for (lli x = 1LL; x <= one; ++x)
            add(x, b);
        for (lli x = 1LL; x <= two; ++x)
            add(x, b);

        lli t = 1LL;
        for (plli p : a)
            t = (t * modpow(p.first, p.second - b[p.first])) % MOD;
        tmp_ans += t;
        return;
    }

    if (one + 2LL * two >= k + 1LL)
        return;

    f(zero + 1LL, one, two);
    f(zero, one + 1LL, two);
    f(zero, one, two + 1LL);
    return;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N;

    ans = 1LL;
    for (lli i = 1LL; i < N; ++i) {
        k = i;
        tmp_ans = 0LL;
        used.clear();
        f(0LL, 0LL, 0LL);
        ans = (ans * tmp_ans) % MOD;
    }

    cout << ans << '\n';
    return 0;
}
