#include <iostream>
#include <unordered_map>
using namespace std;
typedef long long int lli;
typedef pair<lli, lli> plli;
typedef unordered_map<lli, lli>::iterator it;

const lli MAX_SIZE = (lli)5e3 + 1LL,
          MOD = (lli)1e9 + 7LL;

lli N;
lli ans;
unordered_map<lli, lli> fact[MAX_SIZE];

lli modpow(lli base, lli ptr) {
    if (ptr == 0LL)
        return 1LL;
    if (ptr % 2LL == 0LL) {
        lli half = modpow(base, ptr / 2LL);
        return (half * half) % MOD;
    }
    return (base * modpow(base, ptr - 1LL)) % MOD;
}

void add(lli num, unordered_map<lli, lli> &m) {
    for (lli d = 2LL; d * d <= num; ++d)
        while (num % d == 0LL) {
            num /= d;
            ++m[d];
        }
    if (num > 1LL)
        ++m[num];
    return;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N;

    fact[0].clear();
    for (lli i = 1LL; i < N; ++i) {
        fact[i] = fact[i - 1LL];
        add(i, fact[i]);
    }

    ans = 1LL;
    for (lli i = 1LL; i < N; ++i) {
        lli tmp_ans = 0LL;
        for (lli zero = 0LL; zero <= i; ++zero) {
            lli ost = i - zero;
            lli one = 2LL * ost - i - 1LL;
            lli two = ost - one;

            if (one < 0LL)
                break;

            lli t = 1LL;
            for (plli p : fact[i])
                t = (t * modpow(p.first, p.second - fact[zero][p.first] - fact[one][p.first] - fact[two][p.first])) % MOD;
            tmp_ans = (tmp_ans + t) % MOD;
        }
        ans = (ans * tmp_ans) % MOD;
    }

    cout << ans << '\n';
    return 0;
}
