#include <iostream>
#include <algorithm>
#include <numeric>
#include <math.h>
#include <cmath>
#include <string>
#include <map>
#include <vector>
#define int long long
using namespace std;
const long long mod = 1000000007;
long long fact(long long a) {
	long long ans = 1;
	for (long long i = 1; i <= a; i++) {
		ans = (ans * i) % mod;
	}
	return ans % mod;
}
long long egcd(long long a, long long b, long long& x, long long& y) {
	if (a == 0) { x = 0; y = 1; return b; }
	long long x1, y1; int d = egcd(b % a, a, x1, y1);
	x = y1 - (b / a) * x1; y = x1;
	return d;
}

long long revmod(int n, int m) {
	long long x, y;
	long long g = egcd(n, m, x, y);
	return ((x % m) + m) % m;
}

long long moddiv(long long x, long long y) {
	return ((x % mod) * revmod(y, mod)) % mod;
}
long long cnkx(long long n, long long k) {
	return moddiv(moddiv(fact(n), fact(k)), fact(n - k));
}
long long mul(long long a, long long b) {
	return (a * b) % mod;
}
long long cnk(long long n, long long k) {
	int ans1 = 1;
	for (int i = 0; i < k; i++)
		ans1 = mul(ans1, n + i);
	return moddiv(ans1, fact(k));

}
signed main()
{
	int a, b, c, n;
	a = b = c = 0;
	cin >> n;
	for (int i = 0; i < n; i++) {
		int temp; cin >> temp;
		int k = temp % 3;
		if (k == 0)
			a++;
		if (k == 1)
			b++;
		if (k == 2)
			c++;
	}
	if (abs(b - c) != 1 && abs(b - c) != 2) {
		cout << "0\n";
		return 0;
	}
	int nn, kk; nn = b + c; kk = a;
	int ans = mul(fact(b), fact(c));
	ans = mul(ans, fact(a));
	ans = mul(ans, cnk(nn, kk));
	cout << ans << '\n';
}