#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <queue>

using namespace std;

using pii = pair<int, int>;
using ll = long long;
using ld = long double;
using pll = pair<long, long>;

constexpr int mod = 1e9 + 7;
constexpr int MAXN = 2 * 100001;
constexpr int inf = (1 << 30) - 1;

vector<vector<int>> g(MAXN);
vector<int> dp(MAXN), path(MAXN), ans;

void dfs(int u) {
     if (g[u].size() == 0) {
          dp[u] = 0;
          return;
     }

     int ans = inf;
     for (auto to : g[u]) {
          dfs(to);
          ans = min(ans, dp[to]);
     }
     dp[u] = ans + 1;
}

void dfs2(int u, int p = 0){
     dp[u] = min(dp[u], dp[p] + 1);
     for (auto to : g[u]) {
          dfs2(to, u);
     }
}

void find_path(int i) {
     if (path[i] == 1) {
          ans.push_back(1);
          return;
     }
     ans.push_back(path[i]);
     find_path(path[i]);
}

inline void solve(){
     int n;cin >> n;
     for (int i = 2; i <= n; ++i){
          int p;cin >> p;
          g[p].push_back(i);
     }

     dfs(1);
     dp[0] = inf - 5;
     dfs2(1);
     vector<int> dist(n + 1, inf);
     dist[1] = 0;
     queue<int> q;
     q.push(1);
     while (!q.empty()) {
          int u = q.front();
          q.pop();
          for (auto to : g[u]) {
               if (dist[to] > dist[u] + 1) {
                    dist[to] = dist[u] + 1;
                    path[to] = u;
                    q.push(to);
               }
          }
     }

     pii d = {-inf, -1};
     for (int i = 1; i <= n; ++i){
          if (d.first < dist[i]) {
               d = {dist[i], i};
          }
     }

     ans.push_back(d.second);
     find_path(d.second);
     reverse(ans.begin(), ans.end());

     int i = 0;
     int cnt = 0;
     while (ans[i] != d.second){
          int x = dp[ans[i]];
          if (i + x < d.second) {
               i += x;
               ++cnt;
          } else {
               break;
          }
     }

     cout << cnt;
}

#if 0

struct triplet {
     ll a, b, c;
};
vector<triplet> f;

ll ff(int n) {
     if  (f[n - 1].a != 0) {
          f[n].a = f[n-1].a + f[n-1].a * f[n-]
     }
}
inline void solve() {
     int n;
     cin >> n;
     f.resize(n);
     vector<ll> dp(n);
     vector<ll> dp2(n + 1);
     dp2[0] = 1;
     dp2[1] = 1;
     for (int i = 2; i < n; ++i) {
          int a = i / 2;
          ll x = a;
          for (int j = 0; j < a - 1; j++) {
               x *= (a - 2 * j - 1) * (a - 2 * j - 2) % mod;
          }
          dp2[i] = dp2[i-1] * x % mod;
     }
     dp[0] = 1;
     if (n > 1)
          dp[1] = 1;
     for (int i = 2; i < n; ++i) {
          dp[i] = (i * ((i - 1) / 2 + 1) * dp[i-1]) % mod;
     }
     cout << dp.back();
}
#endif


int main() {
     ios_base::sync_with_stdio(false);
     cin.tie(nullptr);

#ifdef DEBUG
     freopen("a.in", "r", stdin);
     freopen("a.out", "w", stdout);
#endif

     int t = 1;
     //cin >> t;
     while (t--) {
          solve();
     }

     return 0;
}
