﻿#pragma optimize("O2");

#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <cmath>
#include <deque>
#include <set>
#include <map>

using namespace std;

using ll = long long;
using ld = long double;

const int MOD = 1e9 + 7;

int mul(int a, int b) {
    return (1ll * a * b) % MOD;
}

int binpow(int bs, int ex) {
    if (ex == 0) return 1;

    if (ex & 1) return mul(bs, binpow(bs, ex - 1));

    int hf = binpow(bs, ex / 2);
    return mul(hf, hf);
}

int fact(int a) {
    if (a == 0) return 1;
    return mul(fact(a - 1), a);
}

int inv(int x) {
    return binpow(x, MOD - 2);
}

int nCk(int n, int k) {
    if (k > n) return 0;

    return mul(fact(n), mul(inv(fact(k)), inv(fact(n - k))));
}

int main() {
    cin.tie(0)->sync_with_stdio(false);
    int n; cin >> n;
    vector<int> cnt(3, 0);
    for (int i = 0; i < n; i++) {
        int x; cin >> x;
        cnt[x % 3]++;
    }
    if ((cnt[1] == 0 && cnt[2] > 2) || (cnt[2] == 0 && cnt[1] > 2)) {
        cout << 0;
        return 0;
    }

    if (cnt[1] > 0 && cnt[2] > 0 && abs(cnt[1] - cnt[2]) != 1) {
        cout << 0;
        return 0;
    }
    int ans = mul(mul(fact(cnt[1]), mul(fact(cnt[2]), nCk(cnt[1] + cnt[2] + cnt[0] - 1, cnt[0]))), fact(cnt[0]));
    cout << ans;
}
