#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define fi first
#define se second
#define pb push_back

const ll MOD = 1'000'000'000 + 7;
const ll INF = 1e18;

ll bin_pow(ll n, ll k)
{
    if (k == 1) return n;
    if (k == 0) return 1;

    if (k % 2 == 0) {
        ll ans = bin_pow(n, k / 2);
        return ans * ans % MOD;
    } else {
        return n * bin_pow(n, k - 1) % MOD;
    }
}

ll dfs(int v, vector<int>& dist, vector <vector<int>>& vc)
{
    if (vc[v].size() == 0)
    {
        dist[v] = 0;
        return 0;
    }
    ll ans = INF;
    for (auto u: vc[v])
    {
        ans = min(dfs(u, dist, vc) + 1, ans);
    }
    dist[v] = ans;
    return ans;
}

void dfs2(int v, vector<int>& dist, vector<int>& ans, vector <vector<int>>& vc, int d, int an)
{
    if (d == 0 && vc[v].size() > 0)
    {
        d = dist[v];
        an++;
        ans[v] = an;
    }
    for (auto u: vc[v])
    {
        dfs2(u, dist, ans, vc, d - 1, an);
    }
}

void solve()
{
    int n;
    cin >> n;
    vector <vector<int>> vc(n);
    for (int i = 0; i < n - 1; i++)
    {
        int v;
        cin >> v;
        vc[v - 1].pb(i + 1);
    }
    vector <int> ans(n);
    vector <int> dist(n);
    dfs(0, dist, vc);
    dfs2(0, dist, ans, vc, dist[0], 0);
    int an = 0;
    for (auto i: ans)
    {
        an = max(an, i);
    }
    cout << an + 1;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }
    return 0;
}
