#include <bits/stdc++.h>
#define fast ios_base::sync_with_stdio(0); cin.tie(0);
#define int long long
#define all(r) r.begin(), r.end()

using namespace std;

struct seg {
    bool canall = true;
    bool canleft = false;
    bool canright = false;
    bool canmid = false;
};

string s;
vector<seg> tr;
seg merge(int m, seg& a, seg& b) {
    seg ret;
    ret.canall = a.canall & b.canall;
    if (!ret.canall) ret.canall = a.canleft & b.canright & (s[m - 1] != 'b' || s[m] != 'b');
    ret.canright = a.canright & b.canall;
    if (!ret.canright) ret.canright = a.canmid & b.canright & (s[m - 1] != 'b' || s[m] != 'b');
    ret.canleft = a.canall & b.canleft;
    if (!ret.canleft) ret.canleft = a.canleft & b.canmid & (s[m - 1] != 'b' || s[m] != 'b');
    ret.canmid = a.canright & b.canleft;
    if (!ret.canmid) ret.canmid = a.canmid & b.canmid & (s[m - 1] != 'b' || s[m] != 'b');
    return ret;
}

void build(int ind, int l, int r) {
    if (l == r) return;
    if (l + 1 == r) {
        tr[ind].canall = s[l] == 'a';
        tr[ind].canleft = true;
        tr[ind].canright = true;
        return;
    }
    int m = (l + r) / 2;
    build(ind * 2 + 1, l, m);
    build(ind * 2 + 2, m, r);
    tr[ind] = merge(m, tr[ind * 2 + 1], tr[ind * 2 + 2]);
}

void change(int ind, int l, int r, int i) {
    if (l == r) return;
    if (l + 1 == r) {
        tr[ind].canall = s[l] == 'a';
        tr[ind].canleft = true;
        tr[ind].canright = true;
        return;
    }
    int m = (l + r) / 2;
    if (i < m) change(ind * 2 + 1, l, m, i);
    else change(ind * 2 + 2, m, r, i);
    tr[ind] = merge(m, tr[ind * 2 + 1], tr[ind * 2 + 2]);
}

seg get_ans(int ind, int l, int r, int ql, int qr) {
    if (l == r || ql >= r || l >= qr) return {};
    if (ql <= l && r <= qr) return tr[ind];
    int m = (l + r) / 2;
    seg ret1 = get_ans(ind * 2 + 1, l, m, ql, qr);
    seg ret2 = get_ans(ind * 2 + 2, m, r, ql, qr);
    return merge(m, ret1, ret2);
}

signed main() {
    fast;
    int n;
    cin >> n >> s;
    tr.resize(4 * n);
    build(0, 0, n);
    int q;
    cin >> q;
    while (q--) {
        int type;
        cin >> type;
        if (type == 1) {
            int x;
            cin >> x;
            --x;
            if (s[x] == 'a') s[x] = 'b';
            else s[x] = 'a';
            change(0, 0, n, x);
        } else {
            int l, r;
            cin >> l >> r;
            if (get_ans(0, 0, n, l - 1, r).canall) {
                cout << "YES\n";
            } else {
                cout << "NO\n";
            }
        }
    }
    return 0;
}
