#include <iostream>
#include <vector>
#include <map>
#include <string>

using namespace std;

using ll = long long;


template <typename T>
istream& operator>>(istream& in, vector<T>& a) {
    for (T& x : a) in >> x;
    return in;
}

string SEP = " ";

template <typename T>
ostream& operator<<(ostream& out, vector<T> a) {
    for (T& x : a) out << x << SEP;
    return out;
}


void RUN(ll RND) {
    ll n;
    cin >> n;

    if (n == 1 || n == 2) {
        cout << 1;
        return;
    }

    ll M = 1e9 + 7;

    vector<vector<ll>> dp(n + 1, vector<ll>(n + 1));

    for (int i = 0; i <= n; ++i) {
        dp[i][1] = (i <= 2 ? 1 : 0);
    }
    for (int k = 2; k <= n; ++k) {
        dp[0][k] = dp[0][k - 1];
        dp[1][k] = (dp[0][k - 1] + dp[1][k - 1]) % M;
        for (int i = 2; i <= n; ++i) {
            dp[i][k] = (dp[i][k - 1] + dp[i - 1][k - 1] + dp[i - 2][k - 1]) % M;
        }
    }

    ll ans = 1;
    for (int i = 2; i <= n; ++i) {
        ans *= dp[i][i - 1];
        ans %= M;
    }
    cout << ans;
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    RUN(0);

    return ('U' ^ 'U');
}
