#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
vector<vector<int>> g;

struct segtree {
    vector<int> t;
    int n;

    void build(int N) {
        n = N;
        t.resize(2 * n, -1e9);
    }

    void update(int p, int val) {
        for (t[p += n] = val; p > 1; p >>= 1) {
            t[p >> 1] = max(t[p], t[p ^ 1]);
        }
    }

    int get_max(int l, int r) {
        int res = -1e9;
        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1) res = max(res, t[l++]);
            if (r & 1) res = max(res, t[--r]);
        }
        return res;
    }
};

vector<segtree> dop;
vector<vector<int>> deep_in, deep_out, deep;
vector<int> tin;
vector<int> tout;
vector<int> dp;
vector<int> closest;
vector<int> pos;
int t = 0;

int dfs(int v, int d) {
    tin[v] = t++;
    pos[v] = (int) deep[d].size();
    deep[d].emplace_back(v);
    closest[v] = 1e9;
    for (auto u: g[v])
        closest[v] = min(closest[v], dfs(u, d + 1));
    if (g[v].empty()) closest[v] = d;
    tout[v] = t++;
    return closest[v];
}

void dfs2(int v, int d) {
    for (auto u: g[v]) {
        dfs2(u, d + 1);
    }
    if (g[v].empty()) {
        dp[v] = 0;
    } else {
        int tec = closest[v];
        int left = lower_bound(deep_in[tec].begin(), deep_in[tec].end(), tin[v]) - deep_in[tec].begin();
        int right = lower_bound(deep_out[tec].begin(), deep_out[tec].end(), tout[v]) - deep_out[tec].begin();
        if (left >= right) {
            dp[v] = 1;
        } else {
            dp[v] = dop[tec].get_max(left, right) + 1;
        }
    }
    dop[d].update(pos[v], dp[v]);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    g.resize(n);
    deep.resize(n);
    dop.resize(n);
    dp.resize(n);
    deep_in.resize(n);
    deep_out.resize(n);
    tin.resize(n);
    tout.resize(n);
    closest.resize(n);
    pos.resize(n);
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        p--;
        g[p].push_back(i);
    }
    dfs(0, 0);
    for (int d = 0; d < n; d++) {
        dop[d].build((int) deep.size());
        for (auto x: deep[d]) {
            deep_in[d].emplace_back(tin[x]);
            deep_out[d].emplace_back(tout[x]);
        }
    }
    dfs2(0, 0);
    cout << dp[0];
    return 0;
}
