#include <bits/stdc++.h>

#define int long long
#define ld long double
using namespace std;

struct segment_tree {
    int n;
    vector<int> tree;

    segment_tree() {}

    segment_tree(const int &n_) {
        n = n_;
        tree.resize(4 * n, 0);
    }

    void update(int v, int tl, int tr, int q, int x) {
        if (tl + 1 == tr) {
            tree[v] = x;
            return;
        }
        int tm = (tl + tr) >> 1;
        if (q < tm)
            update(2 * v + 1, tl, tm, q, x);
        else
            update(2 * v + 2, tm, tr, q, x);
        tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
    }

    int get(int v, int tl, int tr, int ql, int qr) {
        if (qr <= tl || tr <= ql)
            return -1;
        if (ql <= tl && tr <= qr)
            return tree[v];
        int tm = (tl + tr) >> 1;
        return max(get(2 * v + 1, tl, tm, ql, qr), get(2 * v + 2, tm, tr, ql, qr));
    }
};

constexpr int N = 2e5;
vector<int> g[N];
int p[N], h[N], tin[N], tout[N], l[N], dp[N];
unordered_map<int, int> mt[N];
vector<int> who[N];
segment_tree meow[N];
bool leave[N];
int timer = 0;

void dfs(int v) {
    leave[v] = true;
    tin[v] = timer++;
    for (auto &u: g[v]) {
        if (p[v] != u) {
            leave[v] = false;
            h[u] = h[v] + 1;
            dfs(u);
        }
    }
    who[h[v]].emplace_back(v);
    tout[v] = timer++;
}

void dpdfs(int v) {
    l[v] = leave[v] ? -1 : 1e9;
    for (auto &u: g[v]) {
        if (p[v] == u)
            continue;
        dpdfs(u);
        l[v] = min(l[v], l[u]);
    }
    l[v]++;
    int where = h[v] + l[v];
    int n = (int) who[where].size();
    int left = -1, right = n;
    // tin[left] <= tinneed
    int tinneed = tin[v], toutneed = tout[v];
    while (right - left > 1) {
        int mid = (left + right) >> 1;
        (tin[who[where][mid]] <= tinneed ? left : right) = mid;
    }
    int left_br = right;
    left = 0, right = n;
    // tout[left] <= toutneed
    while (right - left > 1) {
        int mid = (left + right) >> 1;
        (tout[who[where][mid]] <= toutneed ? left : right) = mid;
    }
    int right_br = left;
    dp[v] = meow[where].get(0, 0, n, left_br, right_br + 1) + 1;
    meow[h[v]].update(0, 0, (int) who[h[v]].size(), mt[h[v]][v], dp[v]);
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef local
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    p[0] = -1, h[0] = 0;
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[i].emplace_back(p[i]);
        g[p[i]].emplace_back(i);
    }
    dfs(0);
//    for (int v = 0; v < n; v++)
//        cout << v << ' ' << tin[v] << ' ' << tout[v] << endl;
//    for (int i = 0; i < n; i++) {
//        cout << i << ": ";
//        for (auto &v: who[i])
//            cout << v << ' ';
//        cout << endl;
//    }
    for (int i = 0; i < n; i++) {
        meow[i] = segment_tree((int) who[i].size());
        for (int j = 0; j < (int) who[i].size(); j++)
            mt[i][who[i][j]] = j;
    }
    dpdfs(0);
    cout << dp[0];
    return 0;
}
