#include <bits/stdc++.h>

#define int long long
#define pi pair<int,int>
#define ld long double
using namespace std;



struct pt{
    int x, y;
    int id;
    pt operator+(pt p) {
        return {x+p.x, y+p.y};
    }
    pt operator-(pt p) {
        return {x-p.x, y-p.y};
    }
    int operator*(pt p) {
        return x*p.x + y*p.y;
    }
    int operator%(pt p) {
        return x*p.y - y*p.x;
    }
};

int n;
vector <pt> cities;
vector <vector <pi>> g;
vector <pi> edges;

bool cmp(pt a, pt b) {
    pt A = a;
    pt B = b;
    pt n = {1,0};
    bool f1 = (n%A>0) || (n%A==0 && n*A>0);
    bool f2 = (n%B>0) || (n%B==0 && n*B>0);
    if (f1 && (!f2)) return true;
    if (f2 && (!f1)) return false;
    if (A%B != 0) return (A%B > 0);
    return (A*A <= B*B);
}

int u_sort_near;
bool sort_near(pi p1, pi p2) {
    int v1 = p1.first;
    int v2 = p2.first;
    pt o = cities[u_sort_near];
    return cmp(cities[v1] - o, cities[v2] - o);
}

vector <bool> used;
vector <vector <int>> h;
vector <int> color;
void dfs(int u, int cmp_i) {
    used[u] = true;
    color[u] = cmp_i;
    for (auto v: h[u]) if (!used[v]) dfs(v, cmp_i);
    return;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef local
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n;
    cities.resize(n);
    for (auto &city: cities) cin >> city.x >> city.y;
    g.resize(n);
    for (int i = 0; i<n-1; ++i) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back({v,i});
        g[v].push_back({u,i});
        edges.emplace_back(u, v);
        edges.emplace_back(v, u);
    }

    for (int v = 0; v<n; ++v) {
        u_sort_near = v;
        sort(g[v].begin(), g[v].end(), sort_near);
    }

    h.resize(n-1);
    set <pi> cur;


    for (int i = 0; i<2*(n-1); ++i) {
        auto e = edges[i];
        int u = e.first;
        int v = e.second;
        pt vec = cities[v] - cities[u];
        int L = -1;
        int R = g[v].size();
        while (R-L > 1) {
            int M = (L+R)/2;
            int w = g[v][M].first;
            if (cmp(vec, cities[w] - cities[v])) R = M;
            else L = M;
        }
        int id_w1 = R % g[v].size();
        int id_w2 = (R+2*g[v].size()-1) % g[v].size();
        int w1 = g[v][id_w1].first;
        int w2 = g[v][id_w2].first;
        pt vec1 = cities[w1] - cities[v];
        pt vec2 = cities[w2] - cities[v];
        if (vec % vec1 == 0) {if (w1 != u) cur.insert({i>>1, g[v][id_w1].second});}
        else if (vec % vec2 == 0) {if (w2 != u) cur.insert({i>>1, g[v][id_w2].second});}
        else {
            if (w1 != u) {
                cur.insert({i>>1, g[v][id_w1].second});
            };
            if (w2 != u) cur.insert({i>>1, g[v][id_w2].second});
        }
    }

    for (auto el: cur) {
        if (cur.find({el.second, el.first}) != cur.end()) {
            int u = el.first;
            int v = el.second;
            h[u].push_back(v);
            h[v].push_back(u);
        }
    }

    used.resize(n-1, false);
    color.resize(n-1);
    int CMP = 0;
    for (int i = 0; i<n-1; ++i) if (!used[i]) dfs(i, CMP++);

    vector <int> cnt_sizes(n, 0);
    for (int i = 0; i<n-1; ++i) cnt_sizes[color[i]]++;
    int ans = n-1;
    for (int i = 0; i<n; ++i) {
        ans -= cnt_sizes[i] / 2;
    }
    cout <<  ans << endl;


    return 0;
}
