#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;
#pragma GCC optimize("O3", "Ofast")
typedef long long ll;

struct node {
	int sz = 0;
	char lt, rt;
	vector<bool> a;
	node(int sz_, char lt_, char rt_, vector<bool> a_) : sz(sz_), lt(lt_), rt(rt_), a(a_) {}
	node() {}
};

string s;
const int maxn = 1e5;

node tree[1 << 18];

node unite(node a, node b) {
	if (a.sz == 0) return b;
	if (b.sz == 0) return a;
	node res = node(a.sz + b.sz, a.lt, b.rt, { 0, 0, 0, 0 });
	res.a = { a.a[0] && b.a[0], a.a[1] && b.a[0], a.a[0] && b.a[2], a.a[1]&& b.a[2] };
	if (a.rt == 'a' || b.lt == 'a') {
		res.a = {res.a[0] || (a.a[2] && b.a[1]), (a.a[3] && b.a[1]) || res.a[1], (a.a[2] && b.a[3]) || res.a[2], (a.a[3] && b.a[3]) || res.a[3]};
	}
	return res;
}

void build(int v, int l, int r) {
	if (r - l == 1) {
		if (s[l] == 'a') {
			tree[v] = node(1, s[l], s[l], { 1, 1, 1, 0 });
		}
		else {
			tree[v] = node(1, s[l], s[l], { 0, 1,  1, 0 });
		}
		return;
	}
	int m = (l + r) / 2;
	build(2 * v, l, m);
	build(2 * v + 1, m, r);
	tree[v] = unite(tree[2 * v], tree[2 * v + 1]);
}

void upd(int v, int l, int r, int id) {
	if (r - l == 1) {
		if (s[l] == 'a') {
			tree[v] = node(1, s[l], s[l], { 1, 1, 1, 0 });
		}
		else {
			tree[v] = node(1, s[l], s[l], { 0, 1,  1, 0 });
		}
		return;
	}
	int m = (l + r) / 2;
	if (id < m) {
		upd(2 * v, l, m, id);
	}
	else {
		upd(2 * v + 1, m, r, id);
	}
	tree[v] = unite(tree[2 * v], tree[2 * v + 1]);
}

node get(int v, int l, int r, int tl, int tr) {
	if (l >= tr || tl >= r) {
		return node(0, 'a', 'a', { 1, 1, 1, 0 });
	}
	if (l >= tl && r <= tr) {
		return tree[v];
	}
	int m = (l + r) / 2;
	return unite(get(2 * v, l, m, tl, tr), get(2 * v + 1, m, r, tl, tr));
}

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	int n, q;
	cin >> n >> s >> q;
	build(1, 0, n);
	while (q--) {
		int tp;
		cin >> tp;
		if (tp == 1) {
			int id;
			cin >> id;
			--id;
			if (s[id] == 'a') {
				s[id] = 'b';
			}
			else {
				s[id] = 'a';
			}
			upd(1, 0, n, id);
		}
		else {
			int l, r;
			cin >> l >> r;
			--l;
			if (get(1, 0, n, l, r).a[0]) {
				cout << "YES\n";
			}
			else {
				cout << "NO\n";
			}
		}
	}
	return 0;
}