#include <iostream>
#include <iomanip>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll MOD = 1e9 + 7;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n;
    cin >> n;
    vector<vector<ll>> a(n, vector<ll> (n));
    for (ll i = 0; i < n; i++) {
        for (ll j = 0; j < n; j++){
            cin >> a[i][j];
        }
    }
    vector<pair<ll, ll>> sum_r(n, {0, 0});
    for (ll i = 0; i < n; i++) {
        sum_r[i].second = i;
        for (ll j = 0; j < n; j++) {
            sum_r[i].first += a[i][j];
        }
    }
    sort(sum_r.begin(), sum_r.end());
    vector<pair<ll, ll>> sum_c(n, {0, 0});
    for (ll i = 0; i < n; i++) {
        sum_c[i].second = i;
        for (ll j = 0; j < n; j++) {
            sum_c[i].first += a[j][i];
        }
    }
    sort(sum_c.begin(), sum_c.end());
    if (sum_r[0].first == sum_r.back().first && sum_c[0].first == sum_c.back().first) {
        cout << "1 1\n1 1\n";
        return 0;
    }
    if (sum_r[0].first == sum_r.back().first) {
        ll d = (sum_c[0].first - sum_c.back().first) / 2;
        ll x_1 = sum_c[0].second;
        ll x_2 = sum_c.back().second;
        for (int i = 0; i < n; i++) {
            if (a[i][x_1] - a[i][x_2] == d) {
                cout << i + 1 << " " << x_1 + 1 << "\n";
                cout << i + 1 << " " << x_2 + 1 << "\n";
                return 0;
            }
        }
    }
    if (sum_c[0].first == sum_c.back().first) {
        ll d = (sum_r[0].first - sum_r.back().first) / 2;
        ll y_1 = sum_r[0].second;
        ll y_2 = sum_r.back().second;
        for (int i = 0; i < n; i++) {
            if (a[y_1][i] - a[y_2][i] == d) {
                cout << y_1 + 1 << " " << i + 1 << "\n";
                cout << y_2 + 1 << " " << i + 1 << "\n";
                return 0;
            }
        }
    }
    cout << sum_r[0].second + 1 << " " << sum_c[0].second + 1 << "\n";
    cout << sum_r.back().second + 1 << " " << sum_c.back().second + 1 << "\n";
    return 0;
}
