#include <bits/stdc++.h>

using namespace std;

const int mod = 1e9 + 7;

int add(int a, int b) {
    if (a + b >= mod)
        return a + b - mod;
    return a + b;
}

int sub(int a, int b) {
    if (a < b)
        return a - b + mod;
    return a - b;
}

int mul(int a, int b) {
    return (int) ((1ll * a * b) % mod);
}

int binpow(int a, int pw) {
    int b = 1;
    while (pw) {
        if (pw & 1)
            b = mul(b, a);
        a = mul(a, a);
        pw >>= 1;
    }
    return b;
}

int inv(int a) {
    return binpow(a, mod - 2);
}

const int N = 2e5 + 10;
int f[N], r[N];

inline void precalc() {
    f[0] = 1;
    for (int i = 1; i < N; i++)
        f[i] = mul(f[i - 1], i);
    r[N - 1] = inv(f[N - 1]);
    for (int i = N - 2; i > -1; i--)
        r[i] = mul(r[i + 1], i + 1);
}

int C(int n, int k) {
    return mul(f[n], mul(r[k], r[n - k]));
}

inline void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> cnt(3);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        cnt[a[i] % 3]++;
    }
    int ans = 0;
    if (cnt[2] + 1 <= cnt[1] && cnt[1] <= cnt[2] + 2) {
        int comb = mul(f[cnt[2]], f[cnt[1]]);
        comb = mul(comb, C(n - 1, cnt[0]));
        ans = add(ans, comb);
    }
    if (cnt[1] + 1 <= cnt[2] && cnt[2] <= cnt[1] + 2) {
        int comb = mul(f[cnt[2]], f[cnt[1]]);
        comb = mul(comb, C(n - 1, cnt[0]));
        ans = add(ans, comb);
    }
    cout << ans << '\n';
}

int main() {
    precalc();
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
#ifdef DEBUG
    cin >> tt;
#endif
    while (tt--) {
#ifdef DEBUG
        cout << "Test case#\n";
#endif
        solve();
    }
    return 0;
}
