#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <assert.h>
using namespace std;

#define int long long
#define vi vector<int>
#define vvi vector<vector<int>>
#define ff first
#define ss second
#define pi pair<int, int>
const int mod = 1e9 + 7;

int add(int a, int b) {
	if (a + b >= mod)
		return a + b - mod;
	return a + b;
}

int sub(int a, int b) {
	if (a < b)
		return a - b + mod;
	return a - b;
}

int mul(int a, int b) {
	return (int)((1ll * a * b) % mod);
}

int binpow(int a, int pw) {
	int b = 1;
	while (pw) {
		if (pw & 1)
			b = mul(b, a);
		a = mul(a, a);
		pw >>= 1;
	}
	return b;
}

int inv(int a) {
	return binpow(a, mod - 2);
}

int is_sq(int x) {
	int l = 0;
	int r = 1000;
	while (r - l > 1) {
		int m = (r + l) / 2;
		if (m * m >= x) {
			r = m;
		}
		else {
			l = m;
		}
	}
	return r * r == x;
}

int pref[1002][1002];
int pref1[1002][1002];

signed main()
{
	int n;
	cin >> n;
	vvi dp0(n + 1, vi(n + 1));
	vvi dp1(n + 1, vi(n + 1));
	for (int i = 0; i <= n; i++) {
		//dp0[i] = new int[n + 1];
		//dp1[i] = new int[n + 1];
		pref[i][0] = 0;
		pref1[i][0] = 0;
	}
	dp1[1][1] = 2;
	dp1[0][0] = 1;
	for (int i = 1; i <= n; i++) {
		pref1[0][i] = 1;
	}
	for (int i = 2; i <= n; i++) {
		pref1[1][i] = 2;
	}
	for (int i = 2; i <= n; i++) {
		for (int j = 0; j <= n; j++) {
			int t = i - j;
			if (t < 0) continue;
			if (j) dp0[i][j] += pref1[t][j - 1];
			dp1[i][j] += dp1[t][j];
			dp0[i][j] += pref[t][j + 1];

			if (j > 1) dp1[i][j] += dp1[t][j - 1] * (j + 1) % mod * inv(j) % mod;

			dp0[i][j] %= mod;
			dp1[i][j] %= mod;
			
		}
		for (int j = 0; j <= n; j++) {
			pref[i][j + 1] = (pref[i][j] + dp0[i][j]) % mod;
			pref1[i][j + 1] = (pref1[i][j] + dp1[i][j]) % mod;
		}
	}
	int ans = 0;
	for (int i = 0; i <= n; i++) {
		ans += dp0[n][i];
		ans %= mod;
		ans += dp1[n][i];
		ans %= mod;
	}
	cout << ans << endl;
}

