#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

using ll = long long;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int n;
	cin >> n;

	vector<vector<ll>> a(n, vector<ll>(n));
	for (auto& i : a) for (auto& j : i) cin >> j;

	vector<ll> rows(n, 0);
	vector<ll> columns(n, 0);

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			rows[i] += a[i][j];
			columns[j] += a[i][j];
		}
	}

	ll avg = (n * n) * (n * n + 1) / 2 / n;

	map<ll, int> wrongRows;
	map<ll, int> wrongColumns;

	for (int i = 0; i < n; ++i) {
		if (rows[i] != avg) {
			wrongRows[rows[i]] = i;
		}
		if (columns[i] != avg) {
			wrongColumns[columns[i]] = i;
		}
	}

	if (wrongRows.empty()) {
		int c1, c2;
		int r1, r2;
		auto it = wrongColumns.begin();
		c1 = it->second;
		it++;
		c2 = it->second;
		for (int i = 0; i < n; ++i) {
			if ((a[i][c1] - a[i][c2]) * -2 == columns[c1] - columns[c2]) {
				r1 = i;
				r2 = i;
			}
		}

		cout << r1 + 1 << ' ' << c1 + 1 << '\n' << r2 + 1 << ' ' << c2 + 1 << '\n';
		return 0;
	}

	if (wrongColumns.empty()) {
		int c1, c2;
		int r1, r2;
		auto it = wrongRows.begin();
		r1 = it->second;
		it++;
		r2 = it->second;
		for (int i = 0; i < n; ++i) {
			if ((a[r1][i] - a[r2][i]) * 2 == rows[r1] - rows[r2]) {
				c1 = i;
				c2 = i;
			}
		}

		cout << r1 + 1 << ' ' << c1 + 1 << '\n' << r2 + 1 << ' ' << c2 + 1 << '\n';
		return 0;
	}

	auto it1 = wrongRows.begin();
	auto it2 = wrongColumns.begin();

	cout << it1->second + 1 << ' ' << it2->second + 1 << '\n';
	it1++;
	it2++;
	cout << it1->second + 1 << ' ' << it2->second + 1 << '\n';

	return 0;
}