#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1e13;
const ll MOD = 1e9 + 7;


ll binpow(ll n, ll p)
{
	if (p == 0) return 1;
	if (p % 2 == 0)
	{
		ll b = binpow(n, p / 2);
		return (b * b) % MOD;
	}
	return (binpow(n, p - 1) * n) % MOD;
}
vector<vector<int>> g;
vector<int> h;
int dfs(int v)
{
	if (g[v].empty()) h[v] = 0;
	for (int u : g[v])
	{
		h[v] = min(h[v], dfs(u)+1);
	}
	return h[v];
}
int dfs(int v, int k)
{
	int ans = 0;
	multiset<pair<int,int>> hh;
	for (int u : g[v])
	{
		hh.insert({ h[u],u });
	}

	for (int u : g[v])
	{
		auto [mn, mni] = *hh.begin();
		hh.erase(hh.find({ h[u],u }));
		if (!hh.empty())
		{
			auto [mn1, mni1] = *hh.begin();
		if (mn == mn1 && mni == u)
		{
			mn = mn1;
			mni = mni1;
		}
		}
		hh.insert({ h[u],u });
		if (k != 0)
		{
			ans = max(ans, dfs(u, min(k - 1, mn)));
		}
		else
		{
			ans = max(ans, dfs(u, mn));
		}
	}
	if (k == 0 && !g[v].empty()) ans++;
	return ans;
}

void solve()
{
	int n;
	cin >> n;
	g.resize(n);
	h.resize(n,n);
	for (int i = 1; i < n; i++)
	{
		int p;
		cin >> p;
		p--;
		g[p].push_back(i);
	}
	dfs(0);
	cout << dfs(0, 0) << '\n';
}

int main()
{
	int t = 1;
	//cin>>t;
	while (t--) solve();
}