#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
using namespace std;
using ll = long long;
using ld = long double;
const int MOD = 1e9 + 7;

vector<ll> fact;

ll binpow(ll n, ll p)
{
	if (p == 0) return 1;
	if (p % 2 == 0)
	{
		ll b = binpow(n, p / 2);
		return (b * b) % MOD;
	}
	return (binpow(n, p - 1) * n) % MOD;
}

ll C(ll n, ll k)
{
	if (k == 0) return 1;
	return (((fact[n] * binpow(fact[k], MOD - 2)) % MOD) * binpow(fact[n - k], MOD - 2)) % MOD;
}

void solve() 
{
	int n;
	cin >> n;
	fact.resize(n + 1, 1);
	for (int i = 1; i <= n; i++) fact[i] = (fact[i - 1] * i) % MOD;
	ll ans = 1;
	for (int i = 2; i < n; i++)
	{
		ll t = 0;
		for (int x = 0; x <= (i + 1) / 2 - 1; x++)
		{
			//cout << '!' << x << ' ' << C(i,x) << ' ' << C(i-x,x+1) << ' ' << ((C(i, x) * C(i - x, x + 1)) % MOD) << '\n';
			t = (t + ((C(i, x) * C(i - x, x + 1)) % MOD)) % MOD;
		}
		//cout << i << ' ' << t << '\n';
		ans = (ans * t) % MOD;
	}
	cout << ans << '\n';
}

int main()
{
	int t = 1;
	//cin>>t;
	while (t--) solve();
}
