#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
using namespace std;
using ll = long long;
using ld = long double;
const ll MOD = 1e9 + 7;

void solve() 
{
	ll n;
	cin >> n;
	vector<vector<ll>>a(n, vector<ll>(n));
	map<ll, pair<ll, ll>>ind;
	for (ll i = 0; i < n; ++i) {
		for (ll j = 0; j < n; ++j) {
			cin >> a[i][j];
			ind[a[i][j]] = { i, j };
		}
	}
	ll s = (n * n) * (n * n + 1) / 6;
	vector<ll>col(n * n + 1);
	vector<ll>row(n * n + 1);
	vector<ll>colpref(n * n + 1);
	vector<ll>rowpref(n * n + 1);
	
	for (ll i = 0; i < n; ++i) {
		for (ll j = 0; j < n; ++j) {
			if (j == 0) rowpref[a[i][j]] = a[i][j];
			else rowpref[a[i][j]] = rowpref[a[i][j - 1]] + a[i][j];
			if (i == 0) colpref[a[i][j]] = a[i][j];
			else colpref[a[i][j]] = colpref[a[i - 1][j]] + a[i][j];
		}
	}
	for (ll i = 0; i < n; ++i) {
		for (ll j = 0; j < n; ++j) {
			row[a[i][j]] = rowpref[a[i][n - 1]];
			col[a[i][j]] = colpref[a[n - 1][j]];
		}
	}
	set<ll>bad;
	for (ll a = 1; a <= n * n; ++a) {
		if (row[a] != s) {
			bad.insert(a);
		}
	}
	for (ll x : bad) {
		ll y = s - (row[x] - x);
		if (bad.find(y) != bad.end() && s - (row[y] - y) == x) {
			cout << ind[x].first + 1 << ' ' << ind[x].second + 1 << "\n" << ind[y].first + 1 << ' ' << ind[y].second + 1 << "\n";
			return;
		}
	}
}

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	cout.tie(0)->sync_with_stdio(0);
	ll t = 1;
	//cin>>t;
	while (t--) solve();
}
