#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
using namespace std;
using ll = long long;
using ld = long double;
const ll MOD = 1e9 + 7;

void solve() 
{
	ll n;
	cin >> n;
	vector<vector<ll>>a(n, vector<ll>(n));
	map<ll, pair<ll, ll>>ind;
	for (ll i = 0; i < n; ++i) {
		for (ll j = 0; j < n; ++j) {
			cin >> a[i][j];
			ind[a[i][j]] = { i, j };
		}
	}
	ll s = (n * n) * (n * n + 1) / 6;
	vector<ll>col(n);
	vector<ll>row(n);
	
	
	for (ll i = 0; i < n; ++i) {
		for (ll j = 0; j < n; ++j) {
			col[j] += a[i][j];
			row[i] += a[i][j];
		}
	}
	
	set<ll>bad;
	for (ll i = 0; i < n; ++i) {
		for (ll j = 0; j < n; ++j) {
			if (col[j] != s && row[i] != s) {
				ll x = s - (col[j] - a[i][j]);
				ll y = s - (row[i] - a[i][j]);
				if (x == y) {
					bad.insert(a[i][j]);
				}
			}
		}
	}
	for (ll x : bad) {
		auto [i, j] = ind[x];
		ll y = s - (row[i] - x);
		auto [i1, j1] = ind[y];
		if (bad.find(y) != bad.end() && (s - (row[i1] - y)) == x && (s - (col[j1] - y)) == x) {
			cout << i + 1 << ' ' << j + 1 << "\n" << i1 + 1 << ' ' << j1 + 1 << "\n";
			return;
		}
	}
}

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	cout.tie(0)->sync_with_stdio(0);
	ll t = 1;
	//cin>>t;
	while (t--) solve();
}
