#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
using namespace std;
using ll = long long;
using ld = long double;
const ll MOD = 1e9 + 7;

void solve()
{
	ll n;
	cin >> n;
	vector<vector<ll>>a(n, vector<ll>(n));
	map<ll, pair<ll, ll>>ind;
	for (ll i = 0; i < n; ++i) {
		for (ll j = 0; j < n; ++j) {
			cin >> a[i][j];
			ind[a[i][j]] = { i, j };
		}
	}
	ll s = n * (n * n + 1) / 2;
	vector<ll>col(n);
	vector<ll>row(n);


	for (ll i = 0; i < n; ++i) {
		for (ll j = 0; j < n; ++j) {
			col[j] += a[i][j];
			row[i] += a[i][j];
		}
	}


	for (ll x = 1; x <= n * n; ++x) {
		auto [i, j] = ind[x];
		ll y = s - (row[i] - x);
		auto [i1, j1] = ind[y];
		if (i == i1 || j == j1) continue;
		if (row[i]-x+y==s&&col[j]-x+y==s&&row[i1]-y+x==s&&col[j1]-y+x==s) {
			cout << i + 1 << ' ' << j + 1 << "\n" << i1 + 1 << ' ' << j1 + 1 << "\n";
			return;
		}
	}
	bool rr = false;
	for (int i = 0; i < n; i++)
	{
		if (row[i] != s)
		{
			rr = true;
			break;
		}
	}

	if (rr)
	{
		int f = -1, ss = -1;
		for (int i = 0; i < n; i++)
		{
			if (row[i] != s && f == -1) f = i;
			else if (row[i] != s) ss = i;
		}
		for (int j = 0; j < n; j++)
		{
			int l = a[f][j], r = a[ss][j];
			if (row[f] - l + r == s && row[ss] - r + l == s)
			{
				cout << f + 1 << ' ' << j + 1 << '\n' << ss + 1 << ' ' << j + 1 << '\n';
				return;
			}
		}
	}
	else
	{
		int f = -1, ss = -1;
		for (int i = 0; i < n; i++)
		{
			if (col[i] != s && f == -1) f = i;
			else if (col[i] != s) ss = i;
		}
		for (int j = 0; j < n; j++)
		{
			int l = a[j][f], r = a[j][ss];
			if (col[f] - l + r == s && col[ss] - r + l == s)
			{
				cout << j + 1 << ' ' << f + 1 << '\n' << j + 1 << ' ' << ss + 1 << '\n';
				return;
			}
		}
	}
}

int main()
{
	cin.tie(0)->sync_with_stdio(0);
	cout.tie(0)->sync_with_stdio(0);
	int t = 1;
	//cin>>t;
	while (t--) solve();
}
