#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1e13;
const ll MOD = 1e9+7;


ll binpow(ll n, ll p)
{
	if (p == 0) return 1;
	if (p % 2 == 0)
	{
		ll b = binpow(n, p / 2);
		return (b * b) % MOD;
	}
	return (binpow(n, p - 1) * n) % MOD;
}

void solve()
{
	int n;
	cin >> n;
	vector<vector<ll>> ls(n+2,vector<ll>(n+2)), mr(n+3,vector<ll>(n+3));
	ls[1].assign(n + 2, 1);
	ls[1][0] = 0;
	ls[0].assign(n + 2, 1);
	for (int i = 2; i <= n; i++)
	{
		for (int j = 1; j <= n; j++)
		{
			ls[i][j] = ls[i][j - 1];
			if (i >= j)
			{
				ls[i][j] = (ls[i][j] + ls[i - j][j])%MOD;
			}
		}
	}

	mr[1][0] = 1;
	mr[1][1] = 1;
	mr[0].assign(n + 3, 1);
	for (int i = 2; i <= n; i++)
	{
		for (int j = n+1; j >= 1; j--)
		{
			mr[i][j] = mr[i][j + 1];
			if (i >= j)
			{
				mr[i][j] = (mr[i][j] + mr[i - j][j])%MOD;
			}
		}
	}
	ll ans = 0;
	for (ll mex = 1; (mex-1) * mex / 2 <= n; mex++)
	{
		ll sum = (mex-1) * mex / 2;
		if (mex > 1)
		{
			for (ll ss = 0; sum + ss <= n; ss++)
			{
				//cout << mex << ' ' << ss << ' ' << ((((ls[ss][mex - 1] * mr[n - ss - sum][mex + 1]) % MOD) * mex) % MOD) << '\n';
				ans = (ans + ((((ls[ss][mex - 1] * mr[n - ss - sum][mex + 1]) % MOD) * mex) % MOD)) % MOD;
			}
		}
		else
		{
			ans = (ans + ((((mr[n][2]) % MOD)) % MOD)) % MOD;
		}
	}
	cout << ans << '\n';
}

int main()
{
	int t = 1;
	//cin>>t;
	while (t--) solve();
}