#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1e13;
const ll MOD = 1e9+7;


ll binpow(ll n, ll p)
{
	if (p == 0) return 1;
	if (p % 2 == 0)
	{
		ll b = binpow(n, p / 2);
		return (b * b) % MOD;
	}
	return (binpow(n, p - 1) * n) % MOD;
}
struct node {
	int bcnt, left, right, ua, sz;
	node() { bcnt = 0, left = -1, right = -1, ua = 0, sz = 0; }
	node(char c){
		bcnt = 0, left = -1, right = -1, ua = 0, sz = 1;
		if (c == 'b') {
			bcnt = 1;
			left = 2;
			right = 2;
		}
		else {
			left = 0, right = 0;
		}
	}
};
node f(node a, node b) {
	if (b.left == -1)return a;
	if (a.left == -1)return b;
	node ans;
	ans.sz = a.sz + b.sz;
	ans.bcnt = a.bcnt + b.bcnt;
	ans.left = a.left;
	ans.ua = a.ua + b.ua;
	if (a.sz == 1 && a.left == 0 && b.left == 2) {
		ans.left = 1;
		ans.ua++;
	}
	ans.right = b.right;
	if (b.sz == 1 and b.right == 0 and a.right == 2) {
		ans.right = 1;
		ans.ua++;
	}

	if (a.sz > 1 && b.sz > 1 && a.right == 2 and b.left == 0) {
		ans.ua++;
	}
	if (a.sz > 1 && b.sz > 1 && a.right == 0 and b.left == 2) {
		ans.ua++;
	}
	return ans;
}
vector<node>seg_tree;
string s;
void build(int v, int l, int r) {
	if (r - l == 1) {
		seg_tree[v] = node(s[l]);
		return;
	}
	int md = (r + l) / 2;
	build(2 * v + 1, l, md);
	build(2 * v + 2, md, r);
	seg_tree[v] = f(seg_tree[2 * v + 1], seg_tree[2 * v + 2]);
}
node gt(int v, int l, int r, int ql, int qr) {
	if (qr <= l or r <= ql) {
		return node();
	}
	if (ql <= l and r <= qr) {
		return seg_tree[v];
	}
	int md = (r + l) / 2;
	return f(gt(2 * v + 1, l, md, ql, qr), gt(2 * v + 2, md, r, ql, qr));
}
void upd(int v, int l, int r, int i) {
	if (r - l == 1) {
		seg_tree[v] = node(s[l]);
		return;
	}
	int md = (r + l) / 2;
	if (i < md) {
		upd(2 * v + 1, l, md, i);
	}
	else {
		upd(2 * v + 2, md, r, i);
	}
	seg_tree[v] = f(seg_tree[2 * v + 1], seg_tree[2 * v + 2]);
}
void solve() {
	int n; cin >> n;
	cin >> s;
	seg_tree.resize(4 * n);
	build(0, 0, n);
	int q; cin >> q;
	while (q--) {
		int type; cin >> type;
		if (type == 1) {
			int i; cin >> i; --i;
			s[i] = char((((s[i] - 'a') + 1) % 2) + 'a');
			upd(0, 0, n, i);
		}
		else {
			int l, r; cin >> l >> r; --l;
			node kw = gt(0, 0, n, l, r);
			if (kw.ua>=kw.bcnt) {
				cout << "YES\n";
			}
			else {
				cout << "NO\n";
			}
		}
	}
}
int main()
{
	int t = 1;
	//cin>>t;
	while (t--) solve();
}