#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll maxn = 1 << 17;

//#define int long long

struct val {
    int l = 0, r = 0, mx = 0, s = 0;
};

vector<val> tree(2 * maxn);

void build(int n) {
    string s;
    cin >> s;
    for (int i = 0; i < n; ++i) {
        if (s[i] == 'b') {
            tree[i + maxn] = {1, 1, 1, 1};
        }
    }
    for (int i = maxn - 1; i > 0; --i) {
        tree[i].l = tree[i * 2].l;
        tree[i].r = tree[i * 2 + 1].r;
        tree[i].mx = max({tree[i * 2].mx, tree[i * 2 + 1].mx, tree[i * 2].r + tree[i * 2 + 1].l});
        tree[i].s = tree[i * 2].s + tree[i * 2 + 1].s;
    }
}

void upd(int i, int x = 1, int lx = 0, int rx = maxn) {
    if (rx - lx == 1) {
        tree[x] = {1 - tree[x].l, 1 - tree[x].r, 1 - tree[x].mx, 1 - tree[x].s};
        return;
    }
    int mid = (lx + rx) / 2;
    if (i < mid) {
        upd(i, x * 2, lx, mid);
    } else {
        upd(i, x * 2 + 1, mid, rx);
    }
    tree[x] = {tree[i * 2].l, tree[i * 2 + 1].r,
               max({tree[i * 2].mx, tree[i * 2 + 1].mx, tree[i * 2].r + tree[i * 2 + 1].l}),
               tree[i * 2].s + tree[i * 2 + 1].s};
}

val get(int lq, int rq, int x = 1, int lx = 0, int rx = maxn) {
    if (lx >= rq || rx <= lq) {
        return {0, 0, 0,0};
    }
    if (lx >= lq && rx <= rq) {
        return tree[x];
    }
    int mid = (lx + rx) / 2;
    val l = get(lq, rq, x * 2, lx, mid);
    val r = get(lq, rq, x * 2 + 1, mid, rx);
    return {l.l, r.r, max({l.mx, r.mx, l.r + r.l}),l.s + r.s};
}

void solve() {
    int n;
    cin >> n;
    build(n);
    int q;
    cin >> q;
    while (q--) {
        int t;
        cin >> t;
        if (t == 1) {
            int i;
            cin >> i, i--;
            upd(i);
        } else {
            int l, r;
            cin >> l >> r, l--;
            val aboba = get(l, r);
            if (aboba.l > 1 || aboba.r > 0 || aboba.mx > 2 || aboba.s > (r - l)/2) {
                cout << "NO\n";
            } else {
                cout << "YES\n";
            }
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }
}
