#include <bits/stdc++.h>

using namespace std;
using int64 = int64_t;
using uint64 = uint64_t;
using i64 = int64_t;

vector<vector<int>> t;
vector<i64> hsums, vsums;

bool check_swapped(int x1, int x2, int y1, int y2, i64 rsum) {
    i64 hs1, hs2, vs1, vs2;
    hs1 = hsums[x1], hs2 = hsums[x2];
    vs1 = vsums[y1], vs2 = vsums[y2];
    hs1 -= (t[x1][y1] - t[x2][y2]);
    hs2 -= (t[x2][y2] - t[x1][y1]);
    vs1 -= (t[x1][y1] - t[x2][y2]);
    vs2 -= (t[x2][y2] - t[x1][y1]);
    return (hs1 == hs2 && hs1 == rsum && vs1 == vs2 && vs1 == rsum);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n;
    cin >> n;

    t = vector(n, vector<int>(n));
    hsums = vector<i64>(n), vsums = vector<i64>(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> t[i][j];
            hsums[i] += t[i][j];
            vsums[j] += t[i][j];
        }
    }

    if (n == 3) {
        for (int x1 = 0; x1 < n; x1++) {
            for (int x2 = 0; x2 < n; x2++) {
                for (int y1 = 0; y1 < n; y1++) {
                    for (int y2 = 0; y2 < n; y2++) {
                        if (x1 != x2 && y1 != y2) {
                            i64 rsum = (vsums[0] + vsums[1] + vsums[2] - vsums[y1] - vsums[y2]);
                            if (check_swapped(x1, x2, y1, y2, rsum)) {
                                cout << x1 + 1 << " " << y1 + 1 << "\n";
                                cout << x2 + 1 << " " << y2 + 1 << "\n";
                                return 0;
                            }
                        }
                    }
                }
            }
        }
    } else {
        map<i64, int> occ;
        map<i64, int> li;

        i64 rsum = 0;

        for (int i = 0; i < n; i++) {
            i64 s = hsums[i];
            occ[s]++;
            li[s] = i;
        }

        int x1 = -1, x2;
        for (auto [s, c] : occ)
            if (c == 1) {
                if (x1 == -1) x1 = li[s];
                else x2 = li[s];
            } else rsum = s;

        occ.clear();
        li.clear();

        for (int i = 0; i < n; i++) {
            i64 s = vsums[i];
            occ[s]++;
            li[s] = i;
        }

        int y1 = -1, y2;
        for (auto [s, c] : occ)
            if (c == 1) {
                if (y1 == -1) y1 = li[s];
                else y2 = li[s];
            } else rsum = s;

        if (x1 == -1) {
            for (int x1 = 0; x1 < n; x1++) {
                for (int x2 = 0; x2 < n; x2++) {
                    if (check_swapped(x1, x2, y1, y2, rsum)) {
                        cout << x1 + 1 << " " << x2 + 1 << "\n" << y1 + 1 << " " << y2 + 1;
                    }
                }
            }
        } else if (y1 == -1) {
            for (int y1 = 0; y1 < n; y1++) {
                for (int y2 = 0; y2 < n; y2++) {
                    if (check_swapped(x1, x2, y1, y2, rsum)) {
                        cout << x1 + 1 << " " << x2 + 1 << "\n" << y1 + 1 << " " << y2 + 1;
                    }
                }
            }
        } else {
            if (check_swapped(x1, x2, y1, y2, rsum)) {
                cout << x1 + 1 << " " << x2 + 1 << "\n" << y1 + 1 << " " << y2 + 1;
            } else if (check_swapped(x2, x1, y1, y2, rsum)) {
                cout << x2 + 1 << " " << x1 + 1 << "\n" << y1 + 1 << " " << y2 + 1;
            } else if (check_swapped(x1, x2, y2, y1, rsum)) {
                cout << x1 + 1 << " " << x2 + 1 << "\n" << y2 + 1 << " " << y1 + 1;
            } else {
                cout << x2 + 1 << " " << x1 + 1 << "\n" << y2 + 1 << " " << y1 + 1;
            }
        }
    }

    return 0;
}

