#include <iostream>
#include <vector>
#include <string>

using namespace std;


string str(const string &s) {
    return s;
}

string str(int x) {
    return to_string(x);
}

template <typename type>
string str(const vector <type> &v) {
    string s = "[";
    for (int i = 0; i < (int) v.size(); ++i) {
        s += str(v[i]);
        if (i + 1 != (int) v.size()) {
            s += ", ";
        }
    }
    s += "]";
    return s;
}

#define debug(x) cout << (#x) << "=" << str(x) << "\n"


const int inf = 1000000000;

struct solution {
    int n;
    vector <vector <int>> w, q;
    vector <int> h, f;

    void dfs(int u) {
        h[u] = inf;
        for (int v : w[u]) {
            dfs(v);
            h[u] = min(h[u], h[v] + 1);
        }
        if (h[u] == inf) h[u] = 0;
    }

    void calc(int u, int s) {
        f[u] = 0;
        q[s + h[u]].push_back(u);
        for (int v : w[u]) {
            calc(v, s + 1);
        }
        q[s + h[u]].pop_back();
        for (int r : q[s]) {
            f[r] = max(f[r], f[u] + 1);
        }
    }

    void main() {
        cin >> n;

        w.resize(n);
        h.resize(n);
        for (int i = 1; i < n; ++i) {
            int u;
            cin >> u; --u;
            w[u].push_back(i);
        }
        dfs(0);

        q.resize(n);
        f.resize(n);
        calc(0, 0);

        cout << f[0] << '\n';
    }
};

int main() {
    solution s;
    s.main();
}
