#define _GLIBCXX_DEBUG

#include <iostream>
#include <vector>
#include <string>

using namespace std;


string str(const string &s) {
    return s;
}

string str(int x) {
    return to_string(x);
}

template <typename type>
string str(const vector <type> &v) {
    string s = "[";
    for (int i = 0; i < (int) v.size(); ++i) {
        s += str(v[i]);
        if (i + 1 != (int) v.size()) {
            s += ", ";
        }
    }
    s += "]";
    return s;
}

#define debug(x) cout << (#x) << "=" << str(x) << "\n"


const int p = 1000000007;

void calc(int n) {
    int w = 1;
    while (w * (w - 1) / 2 <= n) ++w;

    int s = 0;
    vector <vector <int>> dp(1 + n, vector <int> (1 + n));
    for (int i = 0; i < w; ++i) {
            for (int j = 0; j <= n; ++j) {
                dp[0][j] = 1;
            }
        for (int x = 1; x <= n; ++x) {
                for (int m = 1; m <= n; ++m) {
                    dp[x][m] = dp[x][m - 1];
                    if (m == i) continue;
                    int y = x - m;
                    while (y >= 0) {
                        dp[x][m] += dp[y][m - 1];
                        dp[x][m] %= p;
                        y -= m;
                    }
                }
        }
        s += (long long) i * dp[n - i * (i - 1) / 2][n] % p;
        s %= p;
    }
    cout << s << '\n';
}

int _main() {
    for (int n = 1; n <= 1000; ++n) {
        debug(n);
        calc(n);
    }
}

int main() {
    int n;
    cin >> n;
    calc(n);
}
