#include<bits/stdc++.h>
using namespace std;


struct segtree {
    int n;
    vector<long long> tr;

    segtree() = default;
    segtree(int n) : n(n), tr(vector<long long>(2 * n, 0)) {}

    void update(int k, long long x) {
        for (tr[k += n] = x; k; k >>= 1, tr[k] = tr[k << 1] + tr[k << 1 | 1]);
    }

    long long get(int l, int r) {
        int res = 0;
        for (l += n, r += n; l <= r; l >>= 1, r >>= 1) {
            if (l & 1) res += tr[l++];
            if (~r & 1) res += tr[r--];
        }
        return res;
    }
};

const int N = 2e5 + 100;

int tr[4 * N], upd[4 * N];

void push(int node) {
    tr[node] += upd[node];
    upd[node << 1] += upd[node];
    upd[node << 1 | 1] += upd[node];
    upd[node] = 0;
}

void update(int k, int x, int node = 1, int l = 0, int r = N - 1) {
    push(node);
    if (r < k) return;
    if (k <= l) {
        upd[node] += x;
        push(node);
        return;
    }
    int m = (l + r) / 2;
    update(k, x, node << 1, l, m);
    update(k, x, node << 1 | 1, m + 1, r);
    tr[node] = min(tr[node << 1], tr[node << 1 | 1]);
}

int get(int ql, int qr, int node =1 , int l = 0, int r = N - 1) {
    push(node);
    if (ql <= l && r <= qr) return tr[node];
    if (r < ql || qr < l) return 1e9;
    int m = (l + r) / 2;
    return min(get(ql, qr, node << 1, l, m), get(ql, qr, node << 1 | 1, m + 1, r));
}


int main() {
    cin.tie(0)->sync_with_stdio(0);

    int n;
    cin >> n;
    string s;
    cin >> s;
    segtree triple(n);
    for (int i = 0; i < n; ++i) {
        update(i + 1, (s[i] == 'a') - (s[i] == 'b'));
    }
    for (int i = 0; i + 2 < n; ++i) {
        if (s[i] == 'b' && s[i + 1] == 'b' && s[i + 2] == 'b') {
            triple.update(i, 1);
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int t;
        cin >> t;
        if (t == 2) {
            int l, r;
            cin >> l >> r;
            --l, --r;
//            cout << triple.get(l, r - 2) << ' ' << get(l, r + 1)<< ' ' <<  get(l, l) << endl;
            if (triple.get(l, r - 2) > 0) {
                cout << "NO\n";
            } else if (get(l, r + 1) >= get(l, l) - 1 && get(r + 1, r + 1) - get(l, l) >= 0) {
                cout << "YES\n";
            } else {
                cout << "NO\n";
            }
        } else {
            int k;
            cin >> k;
            --k;
            update(k + 1, (s[k] == 'b') - (s[k] == 'a'));
            for (int i = max(0, k - 2); i + 2 < n && i <= k; ++i) {
                if (s[i] == 'b' && s[i + 1] == 'b' && s[i + 2] == 'b') {
                    triple.update(i, -1);
                }
            }
            if (s[k] == 'a') s[k] = 'b';
            else s[k] = 'a';
            update(k + 1, (s[k] == 'a') - (s[k] == 'b'));
            for (int i = max(0, k - 2); i + 2 < n && i <= k; ++i) {
                if (s[i] == 'b' && s[i + 1] == 'b' && s[i + 2] == 'b') {
                    triple.update(i, 1);
                }
            }
        }
//        for (int i = 0; i < n - 2; ++i) cout << triple.get(i, i) << ' ';
//        cout << endl;
    }
}