#include <bits/stdc++.h>

struct ST {
    struct Data {
        int len;
        char beg;
        char end;
        bool dp[2][2];

        Data(char ch = '-') {
            if (ch == '-') {
                len = 0;
                beg = end = '-';
                memset(dp, 0, sizeof(dp));
                return;
            }
            len = 1;
            beg = ch;
            end = ch;
            if (ch == 'a') {
                dp[0][0] = 1;
                dp[0][1] = 1;
                dp[1][0] = 1;
                dp[1][1] = 0;
            } else {
                dp[0][0] = 0;
                dp[0][1] = 1;
                dp[1][0] = 1;
                dp[1][1] = 0;
            }
        }
    };

    Data merge(Data a, Data b) {
        if (a.len == 0 || b.len == 0) {
            return a.len ? a : b;
        }
        Data c;
        c.len = a.len + b.len;
        c.beg = a.beg;
        c.end = b.end;
        memset(c.dp, 0, sizeof(c.dp));

        for (int i = 0; i < 2; i++) {
            for (int j = 0; j < 2; j++) {
                for (int x = 0; x < 2; x++) {
                    for (int y = 0; y < 2; y++) {
                        if (a.dp[i][j] && b.dp[x][y]) {
                            if (j == 0 && x == 0 ||
                                j == 0 && x == 1 && b.beg == 'a' ||
                                j == 1 && x == 0 && a.end == 'a' ||
                                j == 1 && x == 1 && (a.end != b.beg || a.end == 'a')) {
                                c.dp[i][y] = true;
                            }
                        }
                    }
                }
            }
        }
        return c;
    }

    int size;
    std::vector<Data> data;

    void merge(int i) {
        data[i] = merge(data[2 * i], data[2 * i + 1]);
    }

    ST(std::string s) {
        size = 1 << std::__lg(std::max((int)s.size() - 1, 1)) + 1;
        data.assign(size * 2, Data());
        for (int i = 0; i < s.size(); i++) {
            data[i + size] = Data(s[i]);
        }
        for (int i = size - 1; i > 0; i--) {
            merge(i);
        }
    }

    void update(int i) {
        i += size;
        data[i] = Data('a' + 'b' - data[i].beg);
        for (i >>= 1; i > 0; i >>= 1) {
            merge(i);
        }
    }

    Data get(int l, int r) {
        Data L, R;
        for (l += size, r += size; l < r; l >>= 1, r >>= 1) {
            if (l & 1)
                L = merge(L, data[l++]);
            if (r & 1)
                R = merge(data[--r], R);
        }
        L = merge(L, R);
        return L;
    }
};

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int n;
    std::cin >> n;
    std::string s;
    std::cin >> s;

    ST st(s);
    int q;
    std::cin >> q;
    for (int i = 0; i < q; i++) {
        int t;
        std::cin >> t;
        if (t == 1) {
            int ind;
            std::cin >> ind;
            ind--;
            st.update(ind);
        } else {
            int l, r;
            std::cin >> l >> r;
            l--;
            auto d = st.get(l, r);
            bool ans = d.dp[0][0];
            std::cout << (ans ? "YES\n" : "NO\n");
        }
    }

    return 0;
}
