#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <queue>

using namespace std;
using ll = long long;
using pii = pair<int, int>;
using vint = vector<int>;
#define endl '\n'
#define all(x) x.begin(), x.end()
#define rep(x) for(int ri = 0; ri < x; ++ri)
//#define int long long

const int INF = 2e9 + 7;

const long long LINF = 1e18 + 7;

struct DO {
	int n;
	vector<pii> tree; // ka, kb;
	void build(int v, int vl, int vr, string& ar) {
		if (vl == vr) {
			tree[v] = { ar[vl] == 'a', ar[vl] == 'b' };
			return;
		}
		int vm = (vl + vr) / 2;
		build(v * 2 + 1, vl, vm, ar);
		build(v * 2 + 2, vm + 1, vr, ar);
		tree[v].first = tree[v * 2 + 1].first + tree[v * 2 + 2].first;
		tree[v].second = tree[v * 2 + 1].second + tree[v * 2 + 2].second;
	}

	DO(string& ar) {
		n = size(ar);
		tree.resize(4 * n);
		build(0, 0, n - 1, ar);
	}

	pii query(int v, int vl, int vr, int left, int right) {
		if (right < vl || vr < left)
			return { 0, 0 };
		if (left <= vl && vr <= right)
			return tree[v];
		int vm = (vl + vr) / 2;
		pii ql = query(v * 2 + 1, vl, vm, left, right),
			qr = query(v * 2 + 2, vm + 1, vr, left, right);
		return { ql.first + qr.first, ql.second + qr.second };
	}
	pii query(int l, int r) {
		return query(0, 0, n - 1, l, r);
	}

	void update(int v, int vl, int vr, int pos, int val) { // 0  a -> b   //   1   b -> a
		if (vl == vr) {
			if (val == 0)
				tree[v] = { tree[v].first - 1, tree[v].second + 1 };
			else
				tree[v] = { tree[v].first + 1, tree[v].second - 1 };
			return;
		}
		int vm = (vl + vr) / 2;
		if (pos <= vm)
			update(v * 2 + 1, vl, vm, pos, val);
		else
			update(v * 2 + 2, vm + 1, vr, pos, val);
		tree[v] = { tree[v * 2 + 1].first + tree[v * 2 + 2].first,
		tree[v * 2 + 1].second + tree[v * 2 + 2].second };
	}
	void update(int pos, int val) {
		update(0, 0, n - 1, pos, val);
	}
};

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0);
	cout.precision(10);
	int n;
	string s;
	cin >> n >> s;
	DO do_(s);
	set<int> st; st.insert(n);
	for (int i = 0; i < n - 2; ++i) {
		if (s[i] == 'b' && s[i + 1] == 'b' && s[i + 2] == 'b')
			st.insert(i);
	}
	int q;  cin >> q;
	rep(q) {
		int tp;
		cin >> tp;
		if (tp == 1) {
			int i; cin >> i; i--;
			if (s[i] == 'a') {
				if (i > 1 && s[i - 2] == 'b' && i && s[i - 1] == 'b')
					st.insert(i - 2);
				if (i && s[i - 1] == 'b' && i + 1 < n && s[i + 1] == 'b')
					st.insert(i - 1);
				if (i + 1 < n && s[i + 1] == 'b' && i + 2 < n && s[i + 2] == 'b')
					st.insert(i);
				s[i] = 'b';
				do_.update(i, 0);
			}
			else {
				if (i > 1 && s[i - 2] == 'b' && i && s[i - 1] == 'b')
					st.erase(i - 2);
				if (i && s[i - 1] == 'b' && i + 1 < n && s[i + 1] == 'b')
					st.erase(i - 1);
				if (i + 1 < n && s[i + 1] == 'b' && i + 2 < n && s[i + 2] == 'b')
					st.erase(i);
				s[i] = 'a';
				do_.update(i, 1);
			}
		}
		else {
			int l, r; cin >> l >> r;
			l--; r--;
			if (l == r && s[l] == 'b' ||
				r - l + 1 >= 2 && (s[l] == 'b' && s[l + 1] == 'b' || s[r] == 'b' && s[r - 1] == 'b')) {
				cout << "NO";
			}
			else {
				pii q = do_.query(l, r);
				if (q.first < q.second)
					cout << "NO";
				else {
					int ind = *st.lower_bound(l);
					if (ind + 2 <= r)
						cout << "NO";
					else
						cout << "YES";
				}
			}
			cout << '\n';
		}
	}
}