#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define S second
#define F first
#define int long long


void solve() {
    int n;
    cin >> n;
    vector<vector<int>> mtx(n, vector<int>(n));
    ll sm = 0;
    for (auto &i : mtx) {
        for (auto &j : i) {
            cin >> j;
            sm += j;
        }
    }
    sm /= n;
    vector<int> csm(n), rsm(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            csm[j] += mtx[i][j];
            rsm[i] += mtx[i][j];
        }
    }

    auto check = [&](int i1, int j1, int i2, int j2) {
        int d = mtx[i1][j1] - mtx[i2][j2];
        csm[j1] -= d;
        csm[j2] += d;
        rsm[i1] -= d;
        rsm[i2] += d;
        bool ok =  (csm[j1] == sm) && (csm[j2] == sm) && (rsm[i1] == sm) && (rsm[i2] == sm);
        csm[j1] += d;
        csm[j2] -= d;
        rsm[i1] += d;
        rsm[i2] -= d;
        return ok;
    };

    vector<int> rws, cols;
    for (int i = 0; i < n; i++) {
        if (rsm[i] != sm) rws.emplace_back(i);
        if (csm[i] != sm) cols.emplace_back(i);
    }

    if (rws.empty() && cols.empty()) {
        map<int, pair<int, int>> mp;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (mp.count(mtx[i][j])) {
                    cout << mp[mtx[i][j]].F + 1 << ' ' << mp[mtx[i][j]].S + 1 << endl;
                    cout << i + 1 << ' ' << j + 1 << endl;
                    return;
                } else {
                    mp[mtx[i][j]] = {i, j};
                }
            }
        }
    } else if (rws.empty()) {
        int j1 = cols[0], j2 = cols[1];
        for (int i = 0; i < n; i++) {
            if (check(i, j1, i, j2)) {
                cout << i + 1 << ' ' << j1 + 1 << endl;
                cout << i + 1 << ' ' << j2 + 1 << endl;
                return;
            }
        }
    } else if (cols.empty()) {
        int i1 = rws[0], i2 = rws[1];
        for (int j = 0; j < n; j++) {
            if (check(i1, j, i2, j)) {
                cout << i1 + 1 << ' ' << j + 1 << endl;
                cout << i2 + 1 << ' ' << j + 1 << endl;
                return;
            }
        }
    } else {
        int i1 = rws[0], i2 = rws[1];
        int j1 = cols[0], j2 = cols[1];
        if (check(i1, j1, i2, j2)) {
            cout << i1 + 1 << ' ' << j1 + 1 << endl;
            cout << i2 + 1 << ' ' << j2 + 1 << endl;
            return;
        }
    }
};

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
