//#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

#define int long long

typedef long long ll;

const ll INF = 100'000'000'000'000'000 - 7;

tuple<ll, ll, ll, ll> neu(0, 0, INF, 0);

tuple<ll, ll, ll, ll> merge(tuple<ll, ll, ll, ll> t1, tuple<ll, ll, ll, ll> t2) {
    auto[a1, v1, ca1, cv1] = t1;
    auto[a2, v2, ca2, cv2] = t2;
    ll na = a1 + a2;
    if (v2 > cv1) {
        v2 -= cv1;
        na -= cv1;
        cv1 = 0;
        ll x = min(v2, ca1);
        ca1 -= x;
        v1 += x;
    } else {
        na -= v2;
        cv1 -= v2;
        v2 = 0;
    }
    if (ca2 > cv1) {
        ca1 = min(ca1, ca2 - cv1);
    } else {
        cv1 = ca2;
        ca1 = 0;
    }
    cv1 += cv2;
    return make_tuple(na, v1, ca1, cv1);
}

tuple<ll, ll, ll, ll> make(ll w, ll d) {
    if (w >= d) {
        return make_tuple(0, w - d, d, 0);
    } else {
        return make_tuple(d - w, 0, w, d - w);
    }
}

struct block {
    vector<pair<ll, ll>> arr;
    tuple<ll, ll, ll, ll> all;
    block(vector<ll> w, vector<ll> d) {
        all = neu;
        for (ll i = 0; i < w.size(); i++) {
            arr.push_back(make_pair(w[i], d[i]));
            all = merge(all, make(w[i], d[i]));
        }
    }
    void recalc() {
        all = neu;
        for (auto[w, d] : arr) {
            all = merge(all, make(w, d));
        }
    }
    void set1(ll x, ll y) {
        if (x >= 0 && x < arr.size()) {
            arr[x].first = y;
            recalc();
        }
    }
    void set2(ll x, ll y) {
        if (x >= 0 && x < arr.size()) {
            arr[x].second = y;
            recalc();
        }
    }
    tuple<ll, ll, ll, ll> get(ll l, ll r) {
        if (l < 0) {
            l = 0;
        }
        if (r < 0) {
            return neu;
        }
        if (r >= arr.size()) {
            r = arr.size() - 1;
        }
        if (l == 0 && r == arr.size() - 1) {
            return all;
        }
        tuple<ll, ll, ll, ll> ans = neu;
        for (ll i = l; i <= r; i++) {
            auto[w, d] = arr[i];
            ans = merge(ans, make(w, d));
        }
        return ans;
    }
    bool check(ll l, ll r) {
        if (r + 1 < arr.size()) {
            return true;
        }
        return false;
    }
    ll gl(ll l, ll r) {
        return arr[r + 1].first;
    }
    ll sz() {
        return arr.size();
    }
};

struct SQRT {
    vector<block> arr;
    ll K = 400;
    SQRT(vector<ll> w, vector<ll> d) {
        vector<ll> nw, nd;
        for (ll i = 0; i < w.size(); i++) {
            nw.push_back(w[i]);
            nd.push_back(d[i]);
            if (nw.size() == K || i == w.size() - 1) {
                arr.emplace_back(nw, nd);
                nw.clear();
                nd.clear();
            }
        }
    }
    ll get(ll l, ll r, ll x) {
        tuple<ll, ll, ll, ll> ans = neu;
        r--;
        ll lst = -1;
        for (auto& i : arr) {
            ans = merge(ans, i.get(l, r));
            if (i.check(l, r)) {
                lst = i.gl(l, r);
            }
            l -= i.sz();
            r -= i.sz();
        }
        ll need = max((ll)0, x - lst);
        ans = merge(ans, make(lst, x));
        auto[pisa, popa, chileen, _] = ans;
        return pisa - min(need, popa);
    }
    void set1(ll x, ll y) {
        for (auto& i : arr) {
            i.set1(x, y);
            x -= i.sz();
        }
    }
    void set2(ll x, ll y) {
        for (auto& i : arr) {
            i.set2(x, y);
            x -= i.sz();
        }
    }
};

void solve() {
    ll n, q;
    cin >> n >> q;
    vector<ll> w(n), d(n, 0);
    for (ll i = 0; i < n; i++) {
        cin >> w[i];
    }
    for (ll i = 0; i < n - 1; i++) {
        cin >> d[i];
    }
    SQRT sq(w, d);
    for (ll i = 0; i < q; i++) {
        ll t;
        cin >> t;
        if (t == 1) {
            ll p, x;
            cin >> p >> x;
            p--;
            sq.set1(p, x);
            continue;
        }
        if (t == 2) {
            ll p, x;
            cin >> p >> x;
            p--;
            sq.set2(p, x);
            continue;
        }
        if (t == 3) {
            ll l, r, x;
            cin >> l >> r >> x;
            l--;
            r--;
            cout << sq.get(l, r, x) << '\n';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
