#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

//#define int long long

typedef long long ll;

const ll MOD = 1'000'000'007;

constexpr int R = 1 << 17;

vector<vector<int>> tree[R * 2];

void merge(vector<vector<int>> &ans, vector<vector<int>> &l, vector<vector<int>> &r) {
    for (int ll = 0; ll < 3; ++ll) {
        for (int rr = 0; rr < 3; ++rr) {
            ans[ll][rr] = 0;
            if (l[ll][1] && r[1][rr]) {
                ans[ll][rr] = 1;
            }
            if (l[ll][0] && r[2][rr]) {
                ans[ll][rr] = 1;
            }
            if (l[ll][2] && r[0][rr]) {
                ans[ll][rr] = 1;
            }
        }
    }
}

void build() {
    for (int i = 1; i < R * 2; ++i) {
        tree[i].assign(3, vector<int>(3));
    }
    for (int i = R; i < R * 2; ++i) {
        tree[i][0][0] = tree[i][0][1] = tree[i][1][0] = tree[i][1][1] = 1;
        tree[i][0][2] = tree[i][1][2] = tree[i][2][0] = tree[i][2][1] = tree[i][2][2] = 0;
    }
    for (int i = R - 1; i > 0; --i) {
        merge(tree[i], tree[i * 2], tree[i * 2 + 1]);
    }
}

void change(int pos, char ch) {
    pos += R;
    if (ch == 'a') {
        tree[pos][0][0] = tree[pos][0][1] = tree[pos][1][0] = tree[pos][1][1] = 1;
        tree[pos][0][2] = tree[pos][1][2] = tree[pos][2][0] = tree[pos][2][1] = 1;
        tree[pos][2][2] = 0;
    } else {
        tree[pos][0][0] = tree[pos][0][1] = tree[pos][1][0] = 1;
        tree[pos][1][1] = tree[pos][2][0] = tree[pos][0][2] = tree[pos][1][2] = tree[pos][2][1] = tree[pos][2][2] = 0;
    }
    for (pos /= 2; pos > 0; pos /= 2) {
        merge(tree[pos], tree[pos * 2], tree[pos * 2 + 1]);
    }
}

bool get(int l, int r) {
    l += R;
    r += R;
    vector<vector<int>> ansl = tree[R * 2 - 1], ansr = tree[R * 2 - 1];
    vector<vector<int>> ans_nw = tree[R * 2 - 1];
    while (l < r) {
        if (l & 1) {
            merge(ans_nw, ansl, tree[l]);
            swap(ansl, ans_nw);
            l++;
        }
        if (r & 1) {
            --r;
            merge(ans_nw, tree[r], ansr);
            swap(ansr, ans_nw);
        }
        l >>= 1;
        r >>= 1;
    }
    merge(ans_nw, ansl, ansr);
    if (ans_nw[1][1]) {
        return true;
    }
    return false;
}

void solve() {
    int n;
    cin >> n;
    string s;
    cin >> s;
    build();
    for (int i = 0; i < n; ++i) {
        change(i, s[i]);
    }
    int q;
    cin >> q;
    while (q--) {
        int tp;
        cin >> tp;
        if (tp == 1) {
            int ind;
            cin >> ind;
            ind--;
            if (s[ind] == 'a') {
                s[ind] = 'b';
                change(ind, 'b');
            } else {
                s[ind] = 'a';
                change(ind, 'a');
            }
        } else {
            int l, r;
            cin >> l >> r;
            l--;
            if (get(l, r)) {
                cout << "YES\n";
            } else {
                cout << "NO\n";
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
