#include <bits/stdc++.h>

using namespace std;
#define int long long

const int N = 210000;
const int INF = (int)(1e18);

int n, q, d[N], w[N];

struct seg {
        int mx, mn, res, lz;
        seg() { mx = mn = res = lz = 0;}
        void merge(seg a, seg b) {
            mx = max(a.mx, b.mx);
            mn = min(a.mn, b.mn);
            res = max({a.res, b.res, b.mx - a.mn});
            lz = 0;
        }
    };

struct segtree {
    vector<seg> vv;
    segtree() {}
    segtree(int n) {
        vv = vector<seg>(4 * n + 1);
    }
    void push(int v, int l, int r) {
        if (vv[v].lz == 0) return;
        vv[v].mx += vv[v].lz;
        vv[v].mn += vv[v].lz;
        if (l != r) {
            vv[v * 2 + 0].lz += vv[v].lz;
            vv[v * 2 + 1].lz += vv[v].lz;
        }
        vv[v].lz = 0;
    }
    void upd(int v, int l, int r, int k, int x) {
        push(v, l, r);
        if (l >= k) {
            vv[v].lz += x;
            push(v, l, r);
            return;
        }
        if (r < k) return;
        int mid = (l + r) / 2;
        upd(v * 2 + 0, l, mid, k, x);
        upd(v * 2 + 1, mid + 1, r, k, x);
        vv[v].merge(vv[v * 2 + 0], vv[v * 2 + 1]);
    }
    seg get(int v, int l, int r, int ql, int qr) {
        push(v, l, r);
        if (ql <= l && r <= qr) return vv[v];
        if (qr < l || r < ql) {seg cv = seg(); cv.lz = INF; return cv;}
        int mid = (l + r) / 2;
        seg a = get(v * 2 + 0, l, mid, ql, qr);
        seg b = get(v * 2 + 1, mid + 1, r, ql, qr);
        if (a.lz == INF) return b;
        if (b.lz == INF) return a;
        a.merge(a, b);
        return a;
    }
} cur;

int32_t main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n >> q;
    for (int i = 0; i < n; i++)
        cin >> w[i];
    for (int i = 0; i + 1 < n; i++)
        cin >> d[i];
    cur = segtree(n);
    for (int i = 0; i < n; i++)
        cur.upd(1, 0, n - 1, i, -w[i]);
    for (int i = 0; i + 1 < n; i++)
        cur.upd(1, 0, n - 1, i + 1, d[i]);
    while (q--) {
        int type; cin >> type;
        if (type == 1) {
            int p, x; cin >> p >> x; p--;
            cur.upd(1, 0, n - 1, p, w[p]);
            w[p] = x;
            cur.upd(1, 0, n - 1, p, -w[p]);
        } else if (type == 2) {
            int p, x; cin >> p >> x; p--;
            cur.upd(1, 0, n - 1, p + 1, -d[p]);
            d[p] = x;
            cur.upd(1, 0, n - 1, p + 1, d[p]);
        } else {
            int l, r, x; cin >> l >> r >> x; l--; r--;
            seg ss = cur.get(1, 0, n - 1, l, r);
            int ps = cur.get(1, 0, n - 1, l, l).mn;
            int fs = cur.get(1, 0, n - 1, r, r).mx;
            int cnt = ss.res;
            int pp = ss.mx - ps + fs - ss.mn + x;
            int al = fs - ps + x;
            cnt = max({cnt, pp, al});
            cnt = -cnt;
            if (cnt < 0) cnt = 0;
            cout << cnt << '\n';
        }
    }
}
