#include <bits/stdc++.h>

using namespace std;
//#define int long long
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
using pii = pair <int, int>;

template <typename t1, typename t2>
void mxr(t1& a, const t2& b) {
    if (b > a) {
        a = b;
    }
};
template <typename t1, typename t2>
void mnr(t1& a, const t2& b) {
    if (b < a) {
        a = b;
    }
};

struct Node {
    int ansl = 0;
    int ansr = 0;
    int ans = 0;
    int len = 0;
};

Node merge(Node a, Node b) {
    int ans = max(a.ans, b.ans);
    int ansl = a.ansl;
    int ansr = a.ansr;
    int len = a.len + b.len;
    Node res;
    res.len = len;
    if (a.ansr == a.len) {
        if (b.ansl == b.len) {
            ansl = ansr = a.len + b.len;
        } else {
            ansl = a.ansl + b.ansl;
        }
        mxr(ans, a.len + b.ansl);
    } else if (b.ansl == b.len) {
        ansr = a.ansr + b.ansr;
        mxr(ans, b.len + a.ansr);
    } else {
        mxr(ans, b.ansl + a.ansr);
    }
    res.ans = ans;
    res.ansl = ansl;
    res.ansr = ansr;
    return res;
}

struct Seg {
private:
    vector <Node> d;
    int n;

    void upd(int i) {
        d[i] = merge(d[2 * i], d[2 * i + 1]);
    }

    Node get(int ql, int qr, int l, int r, int i) {
        if (ql >= r || l >= qr || l >= r) {
            return Node{};
        }
        if (l >= ql && r <= qr) {
            return d[i];
        }
        int m = (l + r) / 2;
        return merge(get(ql, qr, l, m, 2 * i),
                     get(ql, qr, m, r, 2 * i + 1));
    }

public:
    explicit Seg(const string& s) {
        n = 1;
        while (n < sz(s)) {
            n <<= 1;
        }
        d.resize(2 * n);
        for (int i = 0; i < sz(s); ++i) {
            d[i].len = 1;
            if (s[i] == 'b') {
                d[i].ansl = d[i].ansr = d[i].ans = 1;
            }
        }
        for (int i = n - 1; i; --i) {
            upd(i);
        }
    }

    int get(int l, int r) {
        return get(l, r, 0, n, 1).ans;
    }

    void upd(int i, char c) {
        i += n;
        int t = 0;
        if (c == 'b') {
            t = 1;
        }
        d[i].ansl = d[i].ansr = d[i].ansl = 1;
        while (i >>= 1) {
            upd(i);
        }
    }
};

struct Sparse {
private:
    vector <vector <int> > d;
    int n;
    vector <int> lg;

public:
    explicit Sparse(const vector <int>& v) {
        n = sz(v);
        lg.resize(n + 1);
        for (int i = 2; i <= n; ++i) {
            lg[i] = lg[i / 2] + 1;
        }
        d.resize(lg[n] + 1, vector <int> (n));
        d[0] = v;
        for (int k = 1; k <= lg[n]; ++k) {
            for (int i = 0; i + (1 << k) <= n; ++i) {
                d[k][i] = max(d[k - 1][i], d[k - 1][i + (1 << (k - 1))]);
            }
        }
    }

    int get(int l, int r) {
        int q = lg[r - l + 1];
        return max(d[q][l], d[q][r - (1 << q) + 1]);
    }
};

const int MAXN = 2e5 + 1;
vector <int> g[MAXN];
int depth[MAXN];
vector <int> bd[MAXN];
vector <int> bin[MAXN];
int mn[MAXN];
int dp[MAXN];
int tin[MAXN], tout[MAXN];

int TIME = 0;

void calcd(int cur) {
    tin[cur] = ++TIME;
    //
    bd[depth[cur]].push_back(cur);
    bin[depth[cur]].push_back(tin[cur]);
    //

    mn[cur] = MAXN + 100;
    for (auto to : g[cur]) {
        depth[to] = depth[cur] + 1;
        calcd(to);
        mnr(mn[cur], mn[to] + 1);
    }

    if (mn[cur] > MAXN) {
        mn[cur] = 0;
    }

    tout[cur] = ++TIME;
}


signed main() {
#ifdef BUY
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    int n;
    cin >> n;
    mt19937 rnd(228);
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
//        p = rnd() % i + 1;
        g[--p].push_back(i);
    }
    depth[0] = 0;
    fill(dp, dp + MAXN, 0);
    calcd(0);
    vector <Sparse*> vec(n);
    for (int i = n - 1; i >= 0; --i) {
        for (auto v : bd[i]) {
            int nextd = depth[v] + mn[v];
            if (nextd == depth[v]) {
                continue;
            }
            int ti = tin[v];
            int to = tout[v];
            auto it = upper_bound(all(bin[nextd]), ti);
            auto it2 = upper_bound(all(bin[nextd]), to);
            if (it2 == bin[nextd].begin()
                || it == bin[nextd].end()) {
                continue;
            }
            int l = it - bin[nextd].begin();
            int r = it2 - bin[nextd].begin() - 1;
            if (l > r) {
                continue;
            }
            dp[v] = vec[nextd]->get(l, r) + 1;
        }
        vector <int> dps;
        for (auto j : bd[i]) {
            dps.push_back(dp[j]);
        }
        vec[i] = new Sparse(dps);
    }
    cout << dp[0];
}