#include "bits/stdc++.h"

using namespace std;

#define int long long
#define vec vector
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rend(), (a).rbegin()

template<typename t>
istream& operator>>(istream& in, vector<t>& v) {
    for (auto& u: v) in >> u;
    return in;
}

const int mod = 1'000'000'007;

const int N = 2e5 + 10;

vector<int> g[N];
int cnt_leaf[N];

int min_dist[N];
int dp[N];
int h[N];

void dfs (int u, int p = -1) {
    min_dist[u] = 1e9;
    h[u] = (p == -1 ? 0 : h[p] + 1);

    for (auto v : g[u]) {
        if (v == p) continue;
        dfs(v, u);
        cnt_leaf[u] += cnt_leaf[v];
        min_dist[u] = min(min_dist[u], min_dist[v]);
    }
    if (cnt_leaf[u] == 0) {
        cnt_leaf[u] = 1;
        min_dist[u] = h[u];
    }
}

map<int, int> rem[N];

void make (int u, int v) {
    if (sz(rem[u]) < sz(rem[v])) {
        rem[u].swap(rem[v]);
    }
    for (auto z : rem[v]) {
        rem[u][z.first] = max(rem[u][z.first], z.second);
    }
    rem[v].clear();
}

void cnt_dp (int u, int p = -1) {
    for (auto v : g[u]) {
        if (v == p) continue;
        cnt_dp(v, u);
        dp[u] = max(dp[u], dp[v]);
        make(u, v);
    }

    if (cnt_leaf[u] == 1) {
        dp[u] = 1;
    } else {
        int H = min_dist[u];
        dp[u] = rem[u][H] + 1;
    }

    rem[u][h[u]] = dp[u];
}

void solve () {
    int n;
    cin >> n;

    for (int i = 1; i < n; i++) {
        int u;
        cin >> u;
        u--;
        g[u].push_back(i);
        g[i].push_back(u);
    }

    dfs(0);
    cnt_dp(0);

    cout << dp[0] << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}