#include "bits/stdc++.h"

using namespace std;

#define int long long
#define vec vector
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rend(), (a).rbegin()

template<typename t>
istream& operator>>(istream& in, vector<t>& v) {
    for (auto& u: v) in >> u;
    return in;
}

const int mod = 1'000'000'007;

const int N = 2e5 + 10;

vec<vec<vec<bool>>> tree(5e5, vec<vec<bool>>(2, vec<bool>(2)));
vec<int> st(5e5);

string s;

bool check(string s) {
    return (s != "bb" && s != "b");
}

vec<vec<bool>> merge(int sz1, int sz2, vec<vec<bool>> a, vec<vec<bool>> b, int l, int r) {
    if (sz1 == 0 && sz2 == 0) return {{0, 0}, {0, 0}};
    if (sz1 == 0) return b;
    if (sz2 == 0) return a;
    vec<vec<bool>> dp(2, vec<bool>(2, false));
    if (sz1 == 1 && sz2 == 1) {
        dp[0][0] = check(s.substr(l, 2));
        dp[0][1] = a[0][0];
        dp[1][0] = b[0][0];
        dp[1][1] = 1;
    }
    else if (sz1 == 1) {
        dp[0][0] = ((a[0][0] & b[0][0]) || (check(s.substr(l, 2)) && b[1][0]));
        dp[1][0] = b[0][0];
        dp[0][1] = ((a[0][0] & b[0][1]) || (check(s.substr(l, 2)) && b[1][1]));
        dp[1][1] = b[0][1];
    }
    else if (sz2 == 1) {
        dp[0][0] = ((a[0][0] & b[0][0]) || (check(s.substr(r - 1, 2)) && a[0][1]));
        dp[1][0] = ((a[1][0] & b[0][0]) || (check(s.substr(r - 1, 2)) && a[1][1]));
        dp[0][1] = a[0][0];
        dp[1][1] = a[1][0];
    }
    else {
        dp[0][0] = ((a[0][0] & b[0][0]) || (a[0][1] & b[1][0] & check(s.substr(l + sz1 - 1, 2))));
        dp[1][0] = ((a[1][0] & b[0][0]) || (a[1][1] & b[1][0] & check(s.substr(l + sz1 - 1, 2))));
        dp[0][1] = ((a[0][0] & b[0][1]) || (a[0][1] & b[1][1] & check(s.substr(l + sz1 - 1, 2))));
        dp[1][1] = ((a[1][0] & b[0][1]) || (a[1][1] & b[1][1] & check(s.substr(l + sz1 - 1, 2))));
    }
    return dp;
}

void build(int i, int l, int r) {
    if (l + 1 == r) {
        tree[i][0][0] = (s[l] == 'a');
        tree[i][1][0] = tree[i][0][1] = tree[i][1][1] = 1;
        st[i] = 1;
        return;
    }
    build(i * 2 + 1, l, (l + r) / 2);
    build(i * 2 + 2, (l + r) / 2, r);
    st[i] = st[i * 2 + 1] + st[i * 2 + 2];
    tree[i] = merge(st[i * 2 + 1], st[i * 2 + 2], tree[i * 2 + 1], tree[i * 2 + 2], l, r - 1);
    //cout << i << " " << l << " " << r << " " << tree[i][0][0] << " " << tree[i][0][1] << " " << tree[i][1][0] << " " << tree[i][1][1] << endl;
}

void upd(int i, int l, int r, int k) {
    if (l + 1 == r) {
        tree[i][0][0] = (s[l] == 'a');
        tree[i][1][0] = tree[i][0][1] = tree[i][1][1] = 1;
        return;
    }
    int m = (r + l) / 2;
    if (k < m) {
        upd(i * 2 + 1, l, (l + r) / 2, k);
    } else {
        upd(i * 2 + 2, (l + r) / 2, r, k);
    }
    tree[i] = merge(st[i * 2 + 1], st[i * 2 + 2], tree[i * 2 + 1], tree[i * 2 + 2], l, r - 1);
}

pair<int, vec<vec<bool>>> get(int i, int l, int r, int ql, int qr) {
    if (ql >= r || l >= qr) return {0, {{0, 0}, {0, 0}}};
    if (ql <= l && r <= qr) return {st[i], tree[i]};
    auto a = get(i * 2 + 1, l, (l + r) / 2, ql, qr);
    auto b = get(i * 2 + 2, (l + r) / 2, r, ql, qr);
    int s_z = a.first + b.first;
    return make_pair(s_z, merge(a.first, b.first, a.second, b.second, max(l, ql), min(r, qr) - 1));
}

void solve () {
    int n;
    cin >> n;
    cin >> s;
    build(0, 0, n);
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int type;
        cin >> type;
        if (type == 1) {
            int x;
            cin >> x;
            x--;
            if (s[x] == 'a') s[x] = 'b';
            else s[x] = 'a';
            upd(0, 0, n, x);
        }
        else {
            int l, r;
            cin >> l >> r;
            if (get(0, 0, n, l - 1, r).second[0][0]) cout << "YES\n";
            else cout << "NO\n";
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}