#include "bits/stdc++.h"

using namespace std;

#pragma GCC optimize("O3")
#pragma GCC target("avx2")

//#define int long long
#define vec vector
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rend(), (a).rbegin()

template<typename t>
istream& operator>>(istream& in, vector<t>& v) {
    for (auto& u: v) in >> u;
    return in;
}

struct node {
    int dp[2][2];
    node () {
        dp[0][0] = dp[1][0] = dp[0][1] = dp[1][1] = 0;
    }
};

node tree[500'000];
vec<int> st(5e5);

string s;

bool check(string &t) {
    return (t != "bb" && t != "b");
}

node merge(int sz1, int sz2, node &a, node &b, int l, int r) {
    if (sz1 == 0 && sz2 == 0) return node();
    if (sz1 == 0) return b;
    if (sz2 == 0) return a;
    vec<vec<int>> dp(2, vec<int>(2, false));
    if (sz1 == 1 && sz2 == 1) {
        string t = string(1, s[l]) + s[l + 1];
        dp[0][0] = check(t);
        dp[0][1] = a.dp[0][0];
        dp[1][0] = b.dp[0][0];
        dp[1][1] = 1;
    }
    else if (sz1 == 1) {
        string t = string(1, s[l]) + s[l + 1];
        bool f = check(t);
        dp[0][0] = ((a.dp[0][0] & b.dp[0][0]) || (f && b.dp[1][0]));
        dp[1][0] = b.dp[0][0];
        dp[0][1] = ((a.dp[0][0] & b.dp[0][1]) || (f && b.dp[1][1]));
        dp[1][1] = b.dp[0][1];
    }
    else if (sz2 == 1) {
        string t = string(1, s[r - 1]) + s[r];
        bool f = check(t);
        dp[0][0] = ((a.dp[0][0] & b.dp[0][0]) || (f && a.dp[0][1]));
        dp[1][0] = ((a.dp[1][0] & b.dp[0][0]) || (f && a.dp[1][1]));
        dp[0][1] = a.dp[0][0];
        dp[1][1] = a.dp[1][0];
    }
    else {
        string t = string(1, s[l + sz1 - 1]) + s[l + sz1];
        bool f = check(t);
        dp[0][0] = ((a.dp[0][0] & b.dp[0][0]) || (a.dp[0][1] & b.dp[1][0] & f));
        dp[1][0] = ((a.dp[1][0] & b.dp[0][0]) || (a.dp[1][1] & b.dp[1][0] & f));
        dp[0][1] = ((a.dp[0][0] & b.dp[0][1]) || (a.dp[0][1] & b.dp[1][1] & f));
        dp[1][1] = ((a.dp[1][0] & b.dp[0][1]) || (a.dp[1][1] & b.dp[1][1] & f));
    }
    node res;
    for (int i = 0; i < 2; i++) {
        for (int j = 0; j < 2; j++) {
            res.dp[i][j] = dp[i][j];
        }
    }
    return res;
}

void build(int i, int l, int r) {
    if (l + 1 == r) {
        tree[i].dp[0][0] = (s[l] == 'a');
        tree[i].dp[1][0] = tree[i].dp[0][1] = tree[i].dp[1][1] = 1;
        st[i] = 1;
        return;
    }
    build(i * 2 + 1, l, (l + r) / 2);
    build(i * 2 + 2, (l + r) / 2, r);
    st[i] = st[i * 2 + 1] + st[i * 2 + 2];
    tree[i] = merge(st[i * 2 + 1], st[i * 2 + 2], tree[i * 2 + 1], tree[i * 2 + 2], l, r - 1);
}

void upd(int i, int l, int r, int k) {
    if (l + 1 == r) {
        tree[i].dp[0][0] = (s[l] == 'a');
        tree[i].dp[1][0] = tree[i].dp[0][1] = tree[i].dp[1][1] = 1;
        return;
    }
    int m = (r + l) / 2;
    if (k < m) {
        upd(i * 2 + 1, l, (l + r) / 2, k);
    } else {
        upd(i * 2 + 2, (l + r) / 2, r, k);
    }
    tree[i] = merge(st[i * 2 + 1], st[i * 2 + 2], tree[i * 2 + 1], tree[i * 2 + 2], l, r - 1);
}

pair<int, node> get(int i, int l, int r, int ql, int qr) {
    if (ql >= r || l >= qr) return {0, node()};
    if (ql <= l && r <= qr) return {st[i], tree[i]};
    auto a = get(i * 2 + 1, l, (l + r) / 2, ql, qr);
    auto b = get(i * 2 + 2, (l + r) / 2, r, ql, qr);
    int s_z = a.first + b.first;
    return make_pair(s_z, merge(a.first, b.first, a.second, b.second, max(l, ql), min(r, qr) - 1));
}

void solve () {
    int n;
    cin >> n;
    cin >> s;
    build(0, 0, n);
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int type;
        cin >> type;
        if (type == 1) {
            int x;
            cin >> x;
            x--;
            if (s[x] == 'a') s[x] = 'b';
            else s[x] = 'a';
            upd(0, 0, n, x);
        }
        else {
            int l, r;
            cin >> l >> r;
            if (get(0, 0, n, l - 1, r).second.dp[0][0]) cout << "YES\n";
            else cout << "NO\n";
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#endif

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}