#include <bits/stdc++.h>

using i64 = long long;

constexpr int N = 1 << 17;

struct Info {
    bool full, noL, noR, noLR;
    char l, r;

    Info() {
        l = r = 'c';
    }

    Info(char x) {
        l = x, r = x;
        if (x == 'a') {
            full = true, noL = true, noR = true, noLR = false;
        } else {
            full = false, noL = true, noR = true, noLR = false;
        }
    }
};

Info operator+(const Info &a, const Info &b) {
    if (b.l == 'c') {
        return a;
    }
    if (a.l == 'c') {
        return b;
    }
    Info res = Info();
    res.l = a.l, res.r = a.r;
    bool t = true;
    if (a.r == 'b' && b.l == 'b') {
        t = false;
    }
    if ((a.full && b.full) || (a.noR && b.noL && t)) {
        res.full = true;
    } else {
        res.full = false;
    }
    if ((a.noL && b.full) || (a.noLR && b.noL && t)) {
        res.noL = true;
    } else {
        res.noL = false;
    }
    if ((a.full && b.noR) || (a.noR && b.noLR && t)) {
        res.noR = true;
    } else {
        res.noR = false;
    }
    if ((a.noL && b.noR) || (a.noLR && b.noLR && t)) {
        res.noLR = true;
    } else {
        res.noLR = false;
    }
    return res;
}

std::vector<Info> info(2 * N);

void modify(int v, int l, int r, int i, char x) {
    if (l == r) {
        info[v] = Info(x);
        return;
    }
    int m = (l + r) / 2;
    if (i <= m) {
        modify(v + v, l, m, i, x);
    } else {
        modify(v + v + 1, m + 1, r, i, x);
    }
    info[v] = info[v + v] + info[v + v + 1];
}

void modify(int i, char x) {
    modify(1, 0, N - 1, i, x);
}

Info query(int v, int l, int r, int tl, int tr) {
    if (r < tl || l > tr) {
        return Info();
    }
    if (l >= tl && r <= tr) {
        return info[v];
    }
    int m = (l + r) / 2;
    return query(v + v, l, m, tl, tr) + query(v + v + 1, m + 1, r, tl, tr);
}

Info query(int l, int r) {
    return query(1, 0, N - 1, l, r);
}

void solve() {
    int n;
    std::cin >> n;
    std::string s;
    std::cin >> s;
    for (int i = 0; i < n; i++) {
        modify(i, s[i]);
    }
    int q;
    std::cin >> q;
    while (q--) {
        int o;
        std::cin >> o;
        if (o == 1) {
            int i;
            std::cin >> i;
            --i;
            if (s[i] == 'a') {
                s[i] = 'b';
            } else {
                s[i] = 'a';
            }
            modify(i, s[i]);
        } else {
            int l, r;
            std::cin >> l >> r;
            --l, --r;
            std::cout << (query(l, r).full ? "YES" : "NO") << "\n";
        }
    }
}

signed main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
    solve();
}
