#include <iostream>
#include <map>
#include <algorithm>
#include <vector>
#include <deque>

using namespace std;

#define int long long

const int mod = 1e9 + 7;

vector<int> least, h;
vector<vector<int>> gr;

void dfs1(int v) {
    least[v] = (gr[v].empty() ? 0 : (int)1e9);
    for (int u : gr[v]) {
        h[u] = h[v] + 1;
        dfs1(u);
        least[v] = min(least[v], least[u] + 1);
    }
}

vector<map<int, int>> ret;
vector<int> dp;

void dfs2(int v) {
    ret[v][h[v]] = 0;
    if (gr[v].size() == 0) return;
    for (auto e : gr[v]) {
        dfs2(e);
        if (ret[v].size() > ret[e].size()) swap(ret[v], ret[e]);
        for (auto i : ret[e]) {
            ret[v][i.first] = max(ret[v][i.first], i.second);
        }
    }

    dp[v] = ret[v][h[v] + least[v]] + 1;
    ret[v][h[v]] = dp[v];
}

void solve() {
    int n;
    cin >> n;
    gr.resize(n);
    least.resize(n);
    h.resize(n);
    dp.resize(n);
    ret.resize(n);
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;
        gr[p].push_back(i);
    }
    dfs1(0);
    dfs2(0);
    cout << dp[0];
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int tc = 1;
    // cin >> tc;
    for (int t = 1; t <= tc; ++t) {
        solve();
    }
}