#include <iostream>
#include <map>
#include <vector>

using namespace std;

#define int long long

const int mod = 1e9 + 7;

int binpow(int a, int b) {
    if (b == 0)
        return 1;
    int c = binpow(a, b / 2);
    c = c * c % mod;
    if (b % 2 == 1)
        c = c * a % mod;
    return c;
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> c(5001, vector<int>(5001));
    c[0][0] = 1;
    for (int i = 1; i <= 5000; ++i) {
        c[i][0] = 1;
        for (int j = 1; j <= i; ++j) {
            c[i][j] = c[i - 1][j] + c[i - 1][j - 1];
            if (c[i][j] >= mod) c[i][j] -= mod;
        }
    }
    int ans = 1;
    for (int i = 2; i < n; ++i) {
        int curans = 0;
        for (int ct = 1; ct + ct - 1 <= i; ++ct) {
            curans += c[i][ct] * c[i - ct][ct - 1];
            if (curans >= mod) curans %= mod;
        }
        ans *= curans;
        if (ans >= mod) ans %= mod;
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int tc = 1;
    // cin >> tc;
    for (int t = 1; t <= tc; ++t) {
        solve();
    }
}